<?php
# подключаем необходимые файлы
require_once '../config.php';

# авторизация
if ( $login && $password ) {
	if ( !isset($_COOKIE['login']) ) die();
	if ( !isset($_COOKIE['password']) ) die();

	if ( !$_COOKIE['login'] || $_COOKIE['login'] !=  hash('sha256', $login) ) die();
	if ( !$_COOKIE['password'] || $_COOKIE['password'] != hash('sha256', $password) ) die();
}

$availability = isset($_REQUEST['availability']) ? $_REQUEST['availability'] : 0;
$cat = isset($_REQUEST['cat']) ? $_REQUEST['cat'] : 0;

# получаем список сайтов
$ids = isset($_REQUEST['site']) ? $_REQUEST['site'] : array();
if ( $cat ) $ids = $database->selectCol("SELECT id FROM sites WHERE cat = ?d", $cat);
if ( !$ids ) die();

$sites = $database->select("SELECT * FROM sites WHERE id IN (?a)", $ids);

# инициализируем объекты
$google = new Google($settings->gate_api);
$IDNA = new idna_convert();

# обрабатываем сайты
foreach ($sites as $site) {
	$row = array(
		'site' => $site['id'],
		'date' => date('Y-m-d H:i:s')
	);
	
    $site['domain'] = $IDNA->encode($site['domain']);
	
	$domain_info = $google->get_domain_info($site['domain']);
	
	$row['ip'] = $google->get_ip($site['domain']);
	$row['header'] = $domain_info['header'];
	$row['time'] = $domain_info['time'];
	$row['title'] = $domain_info['title'];
	
	if(!$availability){
		$whois = $google->get_whois($site['domain']);
		if($whois['reg']){
			$row['reg'] = $whois['reg'];
		}
		if($whois['whois_created']) {
			$created = (time() - strtotime($whois['whois_created']))/86400;
			$row['created'] = round($created, 0, PHP_ROUND_HALF_DOWN);
		}
		if($whois['whois_paid']) {
			$paid = (strtotime($whois['whois_paid'])  - time())/86400;
			$row['paid'] = round($paid, 0, PHP_ROUND_HALF_DOWN);
		}
		
		$ssl = $google->get_ssl_info($site['domain']);
		if($ssl['valid_to']) {
			$valid = (strtotime($ssl['valid_to'])  - time())/86400;
			$row['ssl'] = round($valid, 0, PHP_ROUND_HALF_DOWN);
		}
	}
	
	// заносим данные в базу
	foreach ($row as $rk => $rw) if ( is_null($rw) ) $row[ $rk ] = '';
	$rid = $database->selectCell("SELECT id FROM `control` WHERE `site` = ?d", $row['site']);
	if ( $rid )
		$database->query("UPDATE `control` SET ?a WHERE id = ?d", $row, $rid);
	else
		$database->query("INSERT INTO `control` SET ?a", $row);
}