<?php
# подключаем необходимые файлы
require_once '../config.php';

# авторизация
if ( $login && $password ) {
	if ( !isset($_COOKIE['login']) ) die();
	if ( !isset($_COOKIE['password']) ) die();

	if ( !$_COOKIE['login'] || $_COOKIE['login'] !=  hash('sha256', $login) ) die();
	if ( !$_COOKIE['password'] || $_COOKIE['password'] != hash('sha256', $password) ) die();
}

# получаем список сайтов
$ids = isset($_REQUEST['site']) ? $_REQUEST['site'] : array();
if ( !$ids ) die();

$sites = $database->select("SELECT * FROM sites WHERE id IN (?a)", $ids);

# получаем параметры
$get_li_stat = get_req_var('get_li_stat', 0);
$get_wap_stat = get_req_var('get_wap_stat', 0);
$get_ya_stat = get_req_var('get_ya_stat', 0);
$get_gl_stat = get_req_var('get_gl_stat', 0);
$get_yav_stat = get_req_var('get_yav_stat', 0);
$get_m_stat = get_req_var('get_m_stat', 0);
$get_bg_stat = get_req_var('get_bg_stat', 0);
$get_cy_stat = get_req_var('get_cy_stat', 0);
$get_pr_stat = get_req_var('get_pr_stat', 0);
$get_dmca_stat = get_req_var('get_dmca_stat', 0);
$get_ps_stat = get_req_var('get_ps_stat', 0);
$get_month_stat = get_req_var('get_month_stat', 0);

# инициализируем объекты
$google = new Google($settings->gate_api);
$IDNA = new idna_convert();

if($get_dmca_stat) $lumen = new Lumen();

# обрабатываем сайты
foreach ($sites as $site) {
	$row = $database->selectRow("SELECT * FROM `stat` WHERE `site` = ?d ORDER BY date_update DESC", $site['id']);
	$row_today = $database->selectRow("SELECT * FROM `stat` WHERE `site` = ?d AND `date` = ? ORDER BY date_update DESC", $site['id'], date('Y-m-d'));
	
	unset($row['id']);
	$row['site'] = $site['id'];
	$row['date'] = date('Y-m-d');
	$row['date_update'] = date('Y-m-d H:i:s');
	
	$site['domain'] = $IDNA->encode($site['domain']);
	
	// статистика посещений
	$metrica_source = $site['metrica'];
	
	if ( $metrica_source == 'li' && ($get_li_stat || $get_wap_stat || $get_month_stat || $get_ps_stat) && $site['password'] )
		$li = new LiRu($site['domain'], $site['password']);
	
	if ( $get_li_stat && $site['password'] ) {
		if ( $metrica_source == 'yam' )
			$stat = $google->get_yam_stat($site['password']);
		elseif ( $metrica_source == 'ga' )
			$stat = $google->get_ga_stat($site['password']);
		elseif ( $metrica_source == 'li' )
			$stat = $li->get_stat();
		
		$row['visitors'] = $stat['today_visitors'];
		$row['hits'] = $stat['today_hits'];
		$row['visitors_diff'] = $stat['today_visitors_diff'];
		$row['hits_diff'] = $stat['today_hits_diff'];
	}
	elseif ( !empty($row_today) ){
		$row['visitors'] = ($row_today['visitors']) ? $row_today['visitors'] : 0;
		$row['hits'] = ($row_today['hits']) ? $row_today['hits'] : 0;
		$row['visitors_diff'] = ($row_today['visitors_diff']) ? $row_today['visitors_diff'] : 0;
		$row['hits_diff'] = ($row_today['hits_diff']) ? $row_today['hits_diff'] : 0;
	}
	
	if ( $get_month_stat && $site['password'] ) {
		if ( $metrica_source == 'yam' )
			$month = $google->get_yam_month_stat($site['password']);
		elseif ( $metrica_source == 'ga' )
			$month = $google->get_ga_month_stat($site['password']);
		elseif ( $metrica_source == 'li' )
			$month = $li->get_month_stat();
		
		$row_2['site'] = $row['site'];
		$row_2['date'] = $row['date'];
		$row_2['stats'] = $month;
	}
	
	if ( $get_wap_stat && $site['password'] ) {
		if ( $metrica_source == 'li' )
			$wap_stat = $li->get_wap_stat();
		elseif ( $metrica_source == 'ga' )
			$wap_stat = $google->get_ga_wap_stat($site['password']);
		elseif ( $metrica_source == 'yam' )
			$wap_stat = $google->get_yam_wap_stat($site['password']);
		
		$row['wap_visitors'] = $wap_stat['today'];
	}
	elseif ( !empty($row_today) ){
		$row['wap_visitors'] = ($row_today['wap_visitors']) ? $row_today['wap_visitors'] : 0;
	}
	else{
		$row['wap_visitors'] = 0;
	}
	
	if ( $get_ps_stat && $site['password'] ) {
		if ( $metrica_source == 'li' )
			$ps_stats = $li->get_ps_stat();
		elseif ( $metrica_source == 'ga' )
			$ps_stats = $google->get_ga_ps_stat($site['password']);
		elseif ( $metrica_source == 'yam' )
			$ps_stats = $google->get_yam_ps_stat($site['password']);
		
		foreach($ps_stats as $ps_stat){
			if( $ps_stat['ps'] == 'Яндекс') $row['yandex_hits'] = $ps_stat['today'];
			if( $ps_stat['ps'] == 'Google') $row['google_hits'] = $ps_stat['today'];
			if( $ps_stat['ps'] == 'Mail.ru') $row['mail_hits'] = $ps_stat['today'];
			if( $ps_stat['ps'] == 'Bing') $row['bing_hits'] = $ps_stat['today'];
		}
	}
	elseif ( !empty($row_today) ){
		$row['yandex_hits'] = ($row_today['yandex_hits']) ? $row_today['yandex_hits'] : 0;
		$row['google_hits'] = ($row_today['google_hits']) ? $row_today['google_hits'] : 0;
		$row['mail_hits'] = ($row_today['mail_hits']) ? $row_today['mail_hits'] : 0;
		$row['bing_hits'] = ($row_today['bing_hits']) ? $row_today['bing_hits'] : 0;
	}
	else{
		$row['yandex_hits'] = 0;
		$row['google_hits'] = 0;
		$row['mail_hits'] = 0;
		$row['bing_hits'] = 0;
	}
	
	// индексация
	if ( $get_ya_stat ) {
		$ya = $google->get_yandex($site['domain']);
		$row['yandex'] = $ya['index'];
		$sba = ( $ya['virus'] ) ? $ya['virus'] : $ya['adalt'];
		$row['sba'] = ( $sba ) ? $sba : '';
	}
	if ( $get_gl_stat ) 
		$row['google'] = $google->get_indexed($site['domain']);
	if ( $get_yav_stat ) 
		$row['yandex_video'] = $google->get_yandex_video($site['domain']);
	if ( $get_m_stat ) 
		$row['mail'] = $google->get_mail($site['domain']);
	if ( $get_bg_stat ) 
		$row['bing'] = $google->get_bing($site['domain']);
	
	//Пузомерки
	if ( $get_cy_stat )
		$row['cy'] = $google->get_cy($site['domain']);
	if ( $get_pr_stat ) 
		$row['pr'] = $google->get_pr($site['domain']);
	
	if ( $get_dmca_stat )
		$row['dmca'] = $lumen->get_dmca($site['domain']);
		
		
	$row['rkn'] = $google->get_antizapret($site['domain']);
	
	// заносим данные в базу за сегодня
	foreach ($row as $rk => $rw) if ( is_null($rw) ) $row[ $rk ] = '';
	$rid = $database->selectCell("SELECT id FROM `stat` WHERE `site` = ?d AND `date` = ?", $row['site'], $row['date']);
	if ( $rid )
		$database->query("UPDATE `stat` SET ?a WHERE id = ?d", $row, $rid);
	else
		$database->query("INSERT INTO `stat` SET ?a", $row);
	
	// заносим данные за вчера
	if ( $site['password'] && ($get_li_stat || $get_wap_stat || $get_ps_stat) ) {
		$row_1 = array(
			'site' => $site['id'],
			'date' => date('Y-m-d', time()-24*3600)
		);
		
		if ( $get_li_stat ) {
			$row_1['visitors'] = $stat['yesterday_visitors'];
			$row_1['hits'] = $stat['yesterday_hits'];
		}
		if ( $get_wap_stat ){
			$row_1['wap_visitors'] = $wap_stat['yesterday'];
		}
		if ( $get_ps_stat ) {
			foreach($ps_stats as $ps_stat){
				if( $ps_stat['ps'] == 'Яндекс') $row_1['yandex_hits'] = $ps_stat['yesterday'];
				if( $ps_stat['ps'] == 'Google') $row_1['google_hits'] = $ps_stat['yesterday'];
				if( $ps_stat['ps'] == 'Mail.ru') $row_1['mail_hits'] = $ps_stat['yesterday'];
				if( $ps_stat['ps'] == 'Bing') $row_1['bing_hits'] = $ps_stat['yesterday'];
			}
		}
		
		foreach ($row_1 as $rk1 => $rw1) if ( is_null($rw1) ) $row_1[ $rk1 ] = '';
		$rid_1 = $database->selectCell("SELECT id FROM `stat` WHERE `site` = ?d AND `date` = ?", $row_1['site'], $row_1['date']);
		if ( $rid_1 )
			$database->query("UPDATE `stat` SET ?a WHERE id = ?d", $row_1, $rid_1);
		else
			$database->query("INSERT INTO `stat` SET ?a", $row_1);
	}
	
	// заносим данные по месяцам
	if ( $get_month_stat ) {
		foreach ($row_2 as $rk2 => $rw2) if ( is_null($rw2) ) $row_2[ $rk2 ] = '';
		$rid_2 = $database->selectCell("SELECT id FROM `month` WHERE `site` = ?d", $row_2['site']);
		if ( $rid_2 )
			$database->query("UPDATE `month` SET ?a WHERE id = ?d", $row_2, $rid_2);
		else
			$database->query("INSERT INTO `month` SET ?a", $row_2);
	}
	
}

// api.promosite.ru
$ap = $google->get_promosite();
if($ap) $settings->save_option('promosite', $ap);


$database->query("DELETE FROM `stat` WHERE `date` < ?", date('Y-m-d', time()-33*24*3600));
