<?php
/**
 * Класс для вывода контента
 * 
 * @version 1.1.0
 */
class Core_Viewer {
	
	protected $db;
	protected $smarty;
	
	protected $uniqid;
	
	public function __construct() {
		global $database, $smarty;
		
		$this->db = $database;
		$this->smarty = $smarty;
		
		$uniqid = date('Y-m-d').'_'.get_uniq_id();
		$this->uniqid = $uniqid;
		$this->smarty->assign('uniqid', $uniqid);
	}
	
	public function assign($varname, $value) {
		$this->smarty->assign($varname, $value);
	}
	
	public function display( $tplname, $page_title='', $page='' ) {
		
		$this->smarty->assign('page_title', $page_title);
		
		if ( !$page ) $page = basename($tplname, '.tpl');
		$this->smarty->assign('page', $page);
		
		$version = ( file_exists(ROOT.'/version.php') ) ? intval(file_get_contents(ROOT.'/version.php')) : 0;
		$this->smarty->assign('version', $version);
		
		$content = $this->smarty->fetch( $tplname );
		$this->smarty->assign('content', $content);
		
		$this->smarty->display('index.tpl');
	}
	
	public function error() {
		$this->display('error.tpl', 'Страница не существует', __FUNCTION__);
	}
	
}
