<?php
/**
 * 
 * @version  0.0.1
 */
class Lumen {
    private $browser;
    private $use_proxy = false;
    
	public function __construct() {
        
        $this->IDNA = new idna_convert();
        
		$this->browser = new Curl();
        $this->browser->set_timeout('1200');
        $this->browser->set_headers(
                    array(
                        'Accept: application/json',
                        'Content-type: application/json',
                    )
                );
        
        $proxy = new Proxy();
        $proxy_list = $proxy->get_proxy_list_ok();
        if ($proxy_list){
            $this->browser->use_proxy($proxy_list['list'], false, $proxy_list['auth']);
            $this->browser->shuffle_proxy();
            $this->use_proxy = true;
        }
	}

    public function get_dmca($site) {
        $site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
        $site = $this->IDNA->encode($site);
        
        $data = $this->browser->get_page("https://lumendatabase.org/notices/search?term=$site&term-require-all=yes");
        $data = json_decode($data);
        $data = $data->meta->facets->topic_facet->buckets;
        
        $doc_count = '0';
        foreach($data as $val) if($val->doc_count > $doc_count) $doc_count = $val->doc_count;
        
        if($this->use_proxy) $this->browser->shuffle_proxy();
        
        return $doc_count;
    }
    
}