<?php
/**
 * 
 * @version  0.0.1
 */
class Proxy {
    private $browser;
    
	public function __construct() {
        
        global $settings;
        $this->settings = $settings;
        
		$this->browser = new Curl();
        $this->browser->set_timeout('1');

	}

    public function get_proxy_list() {
        if ( $this->settings->proxy_link || $this->settings->proxy_list ){
			$proxy_list = false;
			$proxy_link = $this->settings->proxy_link;
			if ( $proxy_link ) @$proxy_list = file_get_contents($proxy_link);
			if ( !$proxy_list ) $proxy_list = $this->settings->proxy_list;
			if ( $proxy_list ) $proxy_list = explode("\n", $proxy_list);
			if ( !$proxy_list ) $proxy_list = array();
			
			return array(
                    'list' => $proxy_list,
                    'type' => false,
                    'auth' => $this->settings->proxy_auth
                );
		}
        
        return false;
        
    }
    
    public function get_proxy_list_ok() {
        if($this->settings->proxy_link_ok){
            return array(
                    'list' => $this->settings->proxy_link_ok,
                    'type' => false,
                    'auth' => $this->settings->proxy_auth
                );
        }
        
        return $this->get_proxy_list();
    }
    
    public function get_proxy_list_bad() {
        return $this->settings->proxy_link_bad;
    }
    
    public function proxy_check() {
        $proxy_list_work = array(
                            'ok' => false,
                            'bad' => false,
                        );
        $proxy = $this->get_proxy_list();
        
        if($proxy['list'])
        {
            $this->browser->use_proxy($proxy['list'], false, $proxy['auth']);
            
            foreach($proxy['list'] as $k => $v){
                $this->browser->set_current_proxy($k);
                
                $data = $this->browser->get_page('https://ya.ru/');
                $proxy = $this->browser->get_current_proxy();
                
                if($data) {
                    $proxy_list_work['ok'][] = $proxy;
                } else {
                    $proxy_list_work['bad'][] = $proxy;
                }
            }
            
            $this->settings->save_option('proxy_link_ok', serialize($proxy_list_work['ok']));
            $this->settings->save_option('proxy_link_bad', serialize($proxy_list_work['bad']));
            $this->settings->save_option('proxy_check_time', date('Y-m-d H:i:s'));
        }
        return $proxy_list_work;
    }
}