<?php
/**
 * Драйвер для регистрации в системах статистики
 * 
 * @version  0.0.1
 */
class Reg {
    private $browser;
	private $parser;
    private $use_proxy = false;
    
	public function __construct() {
        
        global $settings;
        $this->settings = $settings;
        
		$this->browser = new Curl();
		//$this->browser->set_sleep(2,5);
        
        $proxy = new Proxy();
        $proxy_list = $proxy->get_proxy_list_ok();
        if ($proxy_list){
            $this->browser->use_proxy($proxy_list['list'], false, $proxy_list['auth']);
            $this->browser->shuffle_proxy();
			$this->use_proxy = true;
        }
		
		$this->parser = new Parser();
        
	}
	
    public function reg_li($params) {
        
        require_once LIBS . '/decaptcha/autoload.php';
        
        $html = $this->browser->get_page('https://www.liveinternet.ru/add');
        if($this->use_proxy) $this->browser->set_channel();
        
        $rnd = $this->parser->parse_string($html, '|name=random value="([\d,]+)">|');
        $img = $this->browser->get_page("http://captcha.li.ru/image?id=$rnd;lang=dig");
        
        $fname = LOG . '/' . get_uniq_id() . '.jpg';
        file_put_contents($fname, $img);
        
        $source = 'services\\'.$this->settings->antigate_source;
        $captcha = new $source([
            $source::ACTION_FIELD_KEY => $this->settings->gate_api,
            $source::ACTION_FIELD_FILE => $fname, 
            $source::ACTION_FIELD_NUMERIC => 1,
        ]);
        if ($captcha->recognize($fname)) {
            $response = $captcha->getCode();
        } else {
            file_put_contents(LOG . '/error_captcha.txt', date('Y-m-d H-i-s').' - '.$captcha->getError().PHP_EOL, FILE_APPEND);
            $captcha->notTrue();
        }
        unlink($fname);
        
        $post = array(
			'random' => $rnd,
			'rules' => 'agreed',
            'type' => 'site',
            'nick' => $params['domain'],
            'name' => $params['domain'],
            'url' => $params['domain'],
            'email' => $params['email'],
            'password' => $params['password'],
            'check' => $params['password'],
            'keywords' => '',
            'aliases' => '',
            'language' => 'ru',
            'group' => '',
            'private' => 'on',
            'subscribe' => 'off',
            'captcha_id' => $rnd,
            'captcha' => $response
		);
        
        $html = $this->browser->get_page('https://www.liveinternet.ru/add', http_build_query($post));
        
    	if ( strpos($html, 'успешно зарегистрирован')!==false ){
    		return '<!--LiveInternet counter--><script type="text/javascript"><!--
document.write("<a href=\'//www.liveinternet.ru/click\' "+
"target=_blank><img src=\'//counter.yadro.ru/hit?t26.18;r"+
escape(document.referrer)+((typeof(screen)=="undefined")?"":
";s"+screen.width+"*"+screen.height+"*"+(screen.colorDepth?
screen.colorDepth:screen.pixelDepth))+";u"+escape(document.URL)+
";"+Math.random()+
"\' alt=\'\' title=\'LiveInternet: показано число посетителей за"+
" сегодня\' "+
"border=\'0\' width=\'0\' height=\'0\'><\/a>")
//--></script><!--/LiveInternet-->';
        }
        
        return false;
    }
    
    public function hide_values_li($params) {
        $html = $this->browser->get_page('https://www.liveinternet.ru/stat/', "url={$params['domain']}&password={$params['password']}", true, true);
        if($this->use_proxy) $this->browser->set_channel();
        $html = $this->browser->get_page("https://www.liveinternet.ru/stat/{$params['domain']}/edit.html", '', true);
        $rnd = $this->parser->parse_string($html, '|name=rnd value=([\d,]+)>|');

        $post = array(
            'report' => 'edit.html',
            'rnd' => $rnd,
            'www' => '',
            'aliases' => '',
            'name' => $params['domain'],
            'email' => $params['email'],
            'rss' => '',
            'newpass' => '',
            'check' => '',
            'newgpass' => '',
            'gcheck' => '',
            'keywords' => '',
            'queries' => '',
            'private' => 'on',
            'language' => 'ru',
            'group' => '',
            'hide_values' => 'on',
            'ok' => 'внести изменения',
            'report' => 'edit.html',
        );
        $html = $this->browser->get_page("https://www.liveinternet.ru/stat/{$params['domain']}/edit.html", http_build_query($post), true);
        
        if($this->use_proxy) $this->browser->shuffle_proxy();
        
        if ( strpos($html, 'описание изменено')!==false || strpos($html, 'описание не изменилось')!==false ){
			return true;
		}
        
		return false;
	}
	
	public function counter_li() {
		$counter = '<!--LiveInternet counter--><script type="text/javascript"><!--
document.write("<a href=\'//www.liveinternet.ru/click\' "+
"target=_blank><img src=\'//counter.yadro.ru/hit?t26.18;r"+
escape(document.referrer)+((typeof(screen)=="undefined")?"":
";s"+screen.width+"*"+screen.height+"*"+(screen.colorDepth?
screen.colorDepth:screen.pixelDepth))+";u"+escape(document.URL)+
";"+Math.random()+
"\' alt=\'\' title=\'LiveInternet: показано число посетителей за"+
" сегодня\' "+
"border=\'0\' width=\'0\' height=\'0\'><\/a>")
//--></script><!--/LiveInternet-->';

		return $counter;
	}
	
	public function reg_yam($params) {
		
		$token = $this->settings->yam_token;
		if ( !$token ) return false;
		
		$param = array(
            'counter' => array(
                'name' => $params['domain'],
                'site2' => array(
                    'site' => $params['domain']
                ),
                'gdpr_agreement_accepted' => '1'
            ),
		);
		$param = json_encode($param);
		
		$opts = array(
			'http' => array(
				'method' => "POST",
				'header' => "Authorization: OAuth " . $token . "\r\n" .
							"Accept: application/x-yametrika+json" . "\r\n" .
							"Content-Type: application/x-yametrika+json" . "\r\n" .
							"Content-length: " . strlen($param) . "\r\n",
				'content' => $param
			)
		);
		$context = stream_context_create($opts);
		$result = file_get_contents("https://api-metrika.yandex.ru/management/v1/counters", null, $context);
		
        return json_decode($result);
	}
	
	public function counter_yam($counter_id) {
		
		$token = $this->settings->yam_token;
		if ( !$token ) return false;
		
		$counters = file_get_contents("https://api-metrika.yandex.ru/management/v1/counter/{$counter_id}?oauth_token={$token}");
		if ( !$counters ) return false;
		
		$counters = json_decode($counters);
		
		return $counters->counter->code;
	}
	
	public function counter_ga($ga_id) {
		
		$token = $this->settings->ga_token;
		if ( !$token ) return $stat;
		
		$client = new Google_Client();
		
		$client->setClientId( $this->settings->ga_id );
		$client->setClientSecret( $this->settings->ga_secret );
		$client->setRedirectUri( 'http://' . $this->settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $this->settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');
		
		$oauth2 = new Google_Service_Oauth2($client);
	
		$client->setAccessToken( $this->settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $this->settings->ga_refresh_token );
			$this->settings->save_option('ga_token', $client->getAccessToken());
		}
		$analytics = new Google_Service_Analytics($client);
		
		$web_properties = $analytics->management_accountSummaries->listManagementAccountSummaries();
		
		foreach($web_properties['items'] as $web){
			foreach($web['webProperties'] as $pro){
				$ids = $pro['id'];
				foreach($pro['profiles'] as $p)
					if($p['id'] == $ga_id) break 2;
			}
		}
		if(!$ids) return false;
		
		$counter = "<script>
  (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

  ga('create', '{$ids}', 'auto');
  ga('send', 'pageview');
</script>";

		return $counter;
	}
    
}