<?php
/**
 * Драйвер для отправки сообщений в telegram
 * 
 * @version  0.0.1
 */
class Telegram {
    private $browser;
    private $use_proxy = false;
    
	public function __construct() {
        
        global $settings;
        $this->settings = $settings;
        
		$this->browser = new Curl();
        
        $proxy = new Proxy();
        $proxy_list = $proxy->get_proxy_list_ok();
        if ($proxy_list){
            $this->browser->use_proxy($proxy_list['list'], false, $proxy_list['auth']);
            $this->browser->shuffle_proxy();
			$this->use_proxy = true;
        }
	}

    public function get_chat() {
        $bot = $this->settings->telegram_token;
        
        $html = $this->browser->get_page("https://api.telegram.org/bot$bot/getUpdates");
        $html = json_decode($html);
        
        $chat_id = $html->result[0]->message->chat->id;
        $username = $html->result[0]->message->chat->username;
        
        return array(
                'telegram_chat_id' => $chat_id,
                'telegram_username' => $username,
            );
    }
    
    public function send_text($text){
        $bot = $this->settings->telegram_token;
        $chat_id = $this->settings->telegram_chat_id;
        
        if($chat_id && $bot){
            $get = array(
                'chat_id' => $chat_id,
                'text' => $text,
            );
            $html = $this->browser->get_page("https://api.telegram.org/bot$bot/sendMessage?".http_build_query($get));
        }
    }
}