<?php
class Viewer extends Core_Viewer {
	
	/**
	 * Страница статистики всех доменов
	 */
	public function stat() {
		// выводим страницу с данными
		$this->assign('host', HOST);
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		# данные яндекс-метрики
		$google = new Google();
		
		# существующие сайты
		$total_visitors_today = 0;
		$total_visitors_yesterday = 0;
		$total_wap_today = 0;
		
		$total_hits_today = 0;
		$total_hits_yesterday = 0;
		$total_wap_yesterday = 0;
		
		$total_hits_diff = 0;
		$total_visitors_diff = 0;
		
		$total_ya = 0;
		$total_yav = 0;
		$total_gl = 0;
		$total_bing = 0;
		
		$count = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE stat = 1");
		$this->assign('count', $count);
		
		$cats = $this->db->select("SELECT * FROM cats");
		foreach($cats as $c){
			$c['count'] = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE cat = ?d AND stat = 1", $c['id']);
			$cat[] = $c;
		}
		$this->assign('cats', $cat);
		
		$this->assign('promosite', $settings->promosite);
		
		$cat_id = isset($_REQUEST['cat']) && intval($_REQUEST['cat']) ? intval($_REQUEST['cat']) : DBSIMPLE_SKIP;
		$this->assign('cat_id', $cat_id);
		
		$sites = $this->db->select("SELECT * FROM sites WHERE {cat = ?d AND} stat = 1 ORDER BY `cat`,`id` ASC", $cat_id);
		
		// Годовой график
		for($i=1; $i <= 12; $i++) {
			$year[] = array(
					'date' => date('M y', strtotime( '+'.$i.' month', time()-31536000 )),
					'hits' => '0',
					'visitors' => '0'
				);
		}
		foreach ($sites as $k => $v) {
			$request = $this->db->selectRow("SELECT * FROM month WHERE site = ?d ORDER BY `date` DESC", $v['id']);
			$month = json_decode($request['stats'], true);
			foreach($month as $km){
				foreach($year as $ky => $vy){
					if( $km['date'] == $vy['date'] ){
						$year[$ky]['hits'] += $km['hits'];
						$year[$ky]['visitors'] += $km['visitors'];
					}
				}
			}
		}
		$this->assign('year', $year);
		
		// Данные для таблицы
		foreach ($sites as $k => $site) {
			$sites[$k]['cat'] = $this->db->selectCell("SELECT title FROM cats WHERE id = ?d", $site['cat']);
			
			$sites[$k]['stat_today'] = $this->db->selectRow("SELECT * FROM `stat` WHERE `site` = ?d AND `date` = ?", $site['id'], date('Y-m-d'));
			$sites[$k]['stat_yesterday'] = $this->db->selectRow("SELECT * FROM `stat` WHERE `site` = ?d AND `date` = ?", $site['id'], date('Y-m-d', time()-24*3600));
			
			if ( !$sites[$k]['stat_today'] && $sites[$k]['stat_yesterday'] ) {
				$sites[$k]['stat_today'] = $sites[$k]['stat_yesterday'];
				$sites[$k]['stat_today']['wap_visitors'] = 0;
				$sites[$k]['stat_today']['visitors_diff'] = 0;
				$sites[$k]['stat_today']['visitors'] = 0;
				$sites[$k]['stat_today']['hits_diff'] = 0;
				$sites[$k]['stat_today']['hits'] = 0;
			}
			
			$sites[$k]['error'] = '';
			if( !$sites[$k]['stat_today']['sba'] || ($sites[$k]['stat_today']['sba'] != 'ok' && $sites[$k]['stat_today']['sba'] != 'Not authorized'.PHP_EOL) )
				$sites[$k]['error'] = $sites[$k]['stat_today']['sba'];
				
			if($sites[$k]['stat_today']['rkn'])
				$sites[$k]['error'] = $sites[$k]['stat_today']['rkn'];
			
			@$sites[$k]['yandex_diff'] = $sites[$k]['stat_today']['yandex'] - $sites[$k]['stat_yesterday']['yandex'];
			@$sites[$k]['yandex_video_diff'] = $sites[$k]['stat_today']['yandex_video'] - $sites[$k]['stat_yesterday']['yandex_video'];
			@$sites[$k]['google_diff'] = $sites[$k]['stat_today']['google'] - $sites[$k]['stat_yesterday']['google'];
			@$sites[$k]['mail_diff'] = $sites[$k]['stat_today']['mail'] - $sites[$k]['stat_yesterday']['mail'];
			@$sites[$k]['bing_diff'] = $sites[$k]['stat_today']['bing'] - $sites[$k]['stat_yesterday']['bing'];
			
			@$total_ya += $sites[$k]['stat_today']['yandex'];
			@$total_ya_diff += $sites[$k]['stat_today']['yandex'] - $sites[$k]['stat_yesterday']['yandex'];
			@$total_yav += $sites[$k]['stat_today']['yandex_video'];
			@$total_yav_diff += $sites[$k]['stat_today']['yandex_video'] - $sites[$k]['stat_yesterday']['yandex_video'];
			@$total_gl += $sites[$k]['stat_today']['google'];
			@$total_gl_diff += $sites[$k]['stat_today']['google'] - $sites[$k]['stat_yesterday']['google'];
			@$total_mail += $sites[$k]['stat_today']['mail'];
			@$total_mail_diff += $sites[$k]['stat_today']['mail'] - $sites[$k]['stat_yesterday']['mail'];
			@$total_bing += $sites[$k]['stat_today']['bing'];
			@$total_bing_diff += $sites[$k]['stat_today']['bing'] - $sites[$k]['stat_yesterday']['bing'];
			
			@$total_visitors_today += $sites[$k]['stat_today']['visitors'];
			@$total_visitors_yesterday += $sites[$k]['stat_yesterday']['visitors'];
			@$total_wap_today += $sites[$k]['stat_today']['wap_visitors'];
			@$total_wap_yesterday += $sites[$k]['stat_yesterday']['wap_visitors'];
			
			@$total_hits_today += $sites[$k]['stat_today']['hits'];
			@$total_hits_yesterday += $sites[$k]['stat_yesterday']['hits'];
			
			@$vdf = $sites[$k]['stat_today']['visitors_diff'];
			if ( strpos($vdf, '+')!==false ) {
				$vdf = str_replace('+', '', $vdf);
				$vdf = intval($vdf);
				$total_visitors_diff += $vdf;
			} elseif ( strpos($vdf, '-')!==false ) {
				$vdf = str_replace('-', '', $vdf);
				$vdf = intval($vdf);
				$total_visitors_diff -= $vdf;
			}
			
			@$hdf = $sites[$k]['stat_today']['hits_diff'];
			if ( strpos($hdf, '+')!==false ) {
				$hdf = str_replace('+', '', $hdf);
				$hdf = intval($hdf);
				$total_hits_diff += $hdf;
			} elseif ( strpos($hdf, '-')!==false ) {
				$hdf = str_replace('-', '', $hdf);
				$hdf = intval($hdf);
				$total_hits_diff -= $hdf;
			}
		}
		
		//Данные для графика
		$array_sites = array(0);
		foreach ($sites as $site) $array_sites[]=$site['id'];
		
		$graph_stats = $this->db->select("SELECT `date`, SUM(`visitors`) as visitors, SUM(`hits`) as hits, SUM(`wap_visitors`) as wap_visitors, SUM(`yandex_hits`) as yandex_hits, SUM(`google_hits`) as google_hits, SUM(`mail_hits`) as mail_hits, SUM(`bing_hits`) as bing_hits FROM `stat` WHERE site IN (?a) GROUP BY `date` ORDER BY `date` DESC LIMIT 30", $array_sites);
		
		$this->assign('sites', $sites);
		
		if(!empty($sites)){
			foreach ($sites as $k) $sites_update[] = $k['stat_today'];
			
			foreach ($sites_update as $key => $item) {
				if(!isset($item['date_update'])) $item['date_update'] = '0';
				$date[$key] = $item['date_update'];
			}
			array_multisort($date, SORT_DESC, $sites);
			
			$sites_current_date = current($sites);
			$time_elapsed['domain'] = $sites_current_date['domain'];
			
			if(!isset($sites_current_date['stat_today']['date_update'])){
				$time_elapsed['date'] = 'никогда не обновлялся';
			}
			else{
				$time_elapsed['date'] = 'обновлено '.time_elapsed_string(strtotime($sites_current_date['stat_today']['date_update']),time()).' назад';
			}
			$this->assign('sites_current_date', $time_elapsed);
			
			$sites_end_date = end($sites);
			$time_elapsed['domain'] = $sites_end_date['domain'];
			if(!isset($sites_end_date['stat_today']['date_update'])){
				$time_elapsed['date'] = 'никогда не обновлялся';
			}
			else{
				$time_elapsed['date'] = 'обновлено '.time_elapsed_string(strtotime($sites_end_date['stat_today']['date_update']),time()).' назад';
			}
			$this->assign('sites_end_date', $time_elapsed);
		}
		
		
		if ( $total_hits_diff > 0 ) $total_hits_diff = "+$total_hits_diff";
		elseif ( $total_hits_diff < 0 ) $total_hits_diff = "$total_hits_diff";
		
		if ( $total_visitors_diff > 0 ) $total_visitors_diff = "+$total_visitors_diff";
		elseif ( $total_visitors_diff < 0 ) $total_visitors_diff = "$total_visitors_diff";
		
		$colspan_index = 0;
		if($settings->view_ya_stat) $colspan_index += 1;
		if($settings->view_yav_stat) $colspan_index += 1;
		if($settings->view_gl_stat) $colspan_index += 1;
		if($settings->view_m_stat) $colspan_index += 1;
		if($settings->view_bg_stat) $colspan_index += 1;
		
		$this->assign('colspan_index', $colspan_index);
		
		$this->assign('total_visitors_today', $total_visitors_today);
		$this->assign('total_visitors_yesterday', $total_visitors_yesterday);
		$this->assign('total_hits_today', $total_hits_today);
		$this->assign('total_hits_yesterday', $total_hits_yesterday);
		$this->assign('total_hits_diff', $total_hits_diff);
		$this->assign('total_visitors_diff', $total_visitors_diff);
		
		$this->assign('total_wap_today', $total_wap_today);
		$this->assign('total_wap_yesterday', $total_wap_yesterday);
		
		$this->assign('total_ya', $total_ya);
		$this->assign('total_ya_diff', $total_ya_diff);
		$this->assign('total_yav', $total_yav);
		$this->assign('total_yav_diff', $total_yav_diff);
		$this->assign('total_gl', $total_gl);
		$this->assign('total_gl_diff', $total_gl_diff);
		$this->assign('total_mail', $total_mail);
		$this->assign('total_mail_diff', $total_mail_diff);
		$this->assign('total_bing', $total_bing);
		$this->assign('total_bing_diff', $total_bing_diff);
		
		$this->assign('graph_stats', $graph_stats);
		
		$this->display('stat.tpl');
	}
	
	public function stat_export(){
		$cat_id = isset($_REQUEST['cat']) && intval($_REQUEST['cat']) ? intval($_REQUEST['cat']) : DBSIMPLE_SKIP;
		$sites = $this->db->select("SELECT * FROM sites WHERE {cat = ?d AND} stat = 1 ORDER BY `cat`,`id` ASC", $cat_id);
		
		foreach ($sites as $k => $site) {
			$sites[$k]['stat_today'] = $this->db->selectRow("SELECT * FROM `stat` WHERE `site` = ?d AND `date` = ?", $site['id'], date('Y-m-d'));
			$sites[$k]['stat_yesterday'] = $this->db->selectRow("SELECT * FROM `stat` WHERE `site` = ?d AND `date` = ?", $site['id'], date('Y-m-d', time()-24*3600));
		}
		
		header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=\"stats.csv\"");
        header("Pragma: no-cache");
        header("Expires: 0");
		
		$handle = fopen('php://output', 'w');
		
		fputcsv($handle, array(
			'Домен',
			'Статистика',
			'Доступ',
			'Хосты',
			'Хиты',
			'WAP',
			'Хосты вчера',
			'Хиты вчера',
			'WAP вчера',
			'Яндекс',
			'Я.Видео',
			'Google',
			'Mail',
			'Bing',
			'ИКС',
			'Яндекс SBA',
			'РКН',
			'DMCA'
		));
		foreach ($sites as $value) {
			fputcsv($handle, array(
				$value['domain'],
				$value['metrica'],
				$value['password'],
				$value['stat_today']['visitors'],
				$value['stat_today']['hits'],
				$value['stat_today']['wap_visitors'],
				$value['stat_yesterday']['visitors'],
				$value['stat_yesterday']['hits'],
				$value['stat_yesterday']['wap_visitors'],
				$value['stat_today']['yandex'],
				$value['stat_today']['yandex_video'],
				$value['stat_today']['google'],
				$value['stat_today']['mail'],
				$value['stat_today']['bing'],
				$value['stat_today']['cy'],
				$value['stat_today']['sba'],
				$value['stat_today']['rkn'],
				$value['stat_today']['dmca']
			));
		}
		
		fclose($handle);
        exit;
	}
	
	/**
	 * Страница контроля
	 */
	public function control() {
		// выводим страницу с данными
		$this->assign('host', HOST);
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		$count = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE control = 1");
		$this->assign('count', $count);
		
		$cats = $this->db->select("SELECT * FROM cats");
		foreach($cats as $c){
			$c['count'] = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE cat = ?d AND control = 1", $c['id']);
			$cat[] = $c;
		}
		$this->assign('cats', $cat);
		
		$cat_id = isset($_REQUEST['cat']) && intval($_REQUEST['cat']) ? intval($_REQUEST['cat']) : DBSIMPLE_SKIP;
		$this->assign('cat_id', $cat_id);
		
		$sites = $this->db->select("SELECT * FROM sites WHERE {cat = ?d AND} control = 1 ORDER BY `cat`,`id` ASC", $cat_id);
		
		foreach ($sites as $k => $site) {
			$data = $this->db->selectRow("SELECT * FROM `control` WHERE `site` = ?d", $site['id']);
			foreach ($data as $key => $val) $sites[$k][$key] = $val;
			$sites[$k]['id'] = $site['id'];
			if(!isset($sites[$k]['date'])) $sites[$k]['date'] = '0';
			$sites[$k]['error'] = ( $sites[$k]['header'] !== '200' || $sites[$k]['time'] > 15 || $sites[$k]['title'] == '' || $sites[$k]['paid'] != '' && $sites[$k]['paid'] < 30 && $sites[$k]['ssl'] < 30 ) ? 1 : 0;
		}
		$this->assign('sites', $sites);
		
		if(!empty($sites)){
			foreach ($sites as $key => $item) {
				if(!isset($item['date'])) $item['date'] = '0';
				$date[$key] = $item['date'];
			}
			array_multisort($date, SORT_DESC, $sites);
			
			$sites_current_date = current($sites);
			$time_elapsed['domain'] = $sites_current_date['domain'];
			if($sites_current_date['date'] == '0'){
				$time_elapsed['date'] = 'никогда не обновлялся';
			}
			else{
				$time_elapsed['date'] = 'обновлено '.time_elapsed_string(strtotime($sites_current_date['date']),time()).' назад';
			}
			$this->assign('sites_current_date', $time_elapsed);
			
			$sites_end_date = end($sites);
			$time_elapsed['domain'] = $sites_end_date['domain'];
			if($sites_end_date['date'] == '0'){
				$time_elapsed['date'] = 'никогда не обновлялся';
			}
			else{
				$time_elapsed['date'] = 'обновлено '.time_elapsed_string(strtotime($sites_end_date['date']),time()).' назад';
			}
			$this->assign('sites_end_date', $time_elapsed);
		}
		
		$this->display('control.tpl');
	}
	
	public function control_export() {
		$cat_id = isset($_REQUEST['cat']) && intval($_REQUEST['cat']) ? intval($_REQUEST['cat']) : DBSIMPLE_SKIP;
		$sites = $this->db->select("SELECT * FROM sites WHERE {cat = ?d AND} control = 1 ORDER BY `cat`,`id` ASC", $cat_id);
		
		foreach ($sites as $k => $site) {
			$data = $this->db->selectRow("SELECT * FROM `control` WHERE `site` = ?d", $site['id']);
			foreach ($data as $key => $val) $sites[$k][$key] = $val;
			$sites[$k]['id'] = $site['id'];
		}
		
		header("Content-type: application/csv");
        header("Content-Disposition: attachment; filename=\"control.csv\"");
        header("Pragma: no-cache");
        header("Expires: 0");
		
		$handle = fopen('php://output', 'w');
		
		fputcsv($handle, array(
			'Домен',
			'IP',
			'Ответ',
			'Время загрузки',
			'Тайтл',
			'Регистратор',
			'Возраст домена',
			'До продления домена',
			'До продления  SSL'
		));
		foreach ($sites as $value) {
			fputcsv($handle, array(
				$value['domain'],
				$value['ip'],
				$value['header'],
				$value['time'],
				$value['title'],
				$value['reg'],
				$value['created'],
				$value['paid'],
				$value['ssl']
			));
		}
		
		fclose($handle);
        exit;
	}
	
	/**
	 * Страница расчета дохода
	 */
	public function finance() {
		
		if ( isset($_REQUEST['income']) ) {
			$cat = intval($_REQUEST['cat']);
			$period = $_REQUEST['period'];
			$profit = $_REQUEST['profit'];
			$expense = $_REQUEST['expense'];
			
			foreach($profit as $k => $v)
				$this->db->query("INSERT INTO income SET `source` = ?d, `period` = ?, `data` = ?d", intval($k), $period, intval($v));
			
			foreach($expense as $k => $v)
				$this->db->query("INSERT INTO income SET `source` = ?d, `period` = ?, `data` = ?d", intval($k), $period, intval($v));
			
			header('Location: /index.php?do=finance&cat='.$cat);
		}
		
		if ( isset($_REQUEST['remove']) ) {
			$id = intval($_REQUEST['remove']);
			$cat = intval($_REQUEST['cat']);
			
			$this->db->query("DELETE FROM sources WHERE id = ?d", $id);
			$this->db->query("DELETE FROM income WHERE source = ?d", $id);
			
			header('Location: /index.php?do=finance&cat='.$cat);
		}
		
		// выводим страницу с данными
		$this->assign('host', HOST);
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		$count = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE stat = 1");
		$this->assign('count', $count);
		
		$cats = $this->db->select("SELECT * FROM cats");
		foreach($cats as $c){
			$c['count'] = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE cat = ?d AND stat = 1", $c['id']);
			$cat[] = $c;
		}
		$this->assign('cats', $cat);
		
		$cat_id = isset($_REQUEST['cat']) && intval($_REQUEST['cat']) ? intval($_REQUEST['cat']) : DBSIMPLE_SKIP;
		$this->assign('cat_id', $cat_id);
		
		$profits = $this->db->select("SELECT * FROM sources WHERE {cat = ?d AND} type = 'profit' ORDER BY `id` DESC", $cat_id);
		$uprofit = array();
		foreach ($profits as $profit)
			if ( !search_in_array($profit['title'], $uprofit) )
				$uprofit[] = $profit;
		
		$this->assign('profits', $uprofit);
		$this->assign('profits_count', count($uprofit));
		
		$expenses = $this->db->select("SELECT * FROM sources WHERE {cat = ?d AND} type = 'expense' ORDER BY `id` DESC", $cat_id);
		$uexpense = array();
		foreach ($expenses as $expense) 
			if ( !search_in_array($expense['title'], $uexpense) )
				$uexpense[] = $expense;
		
		$this->assign('expenses', $uexpense);
		$this->assign('expenses_count', count($uexpense));
		
		$sites = $this->db->select("SELECT * FROM sites WHERE {cat = ?d AND} stat = 1 ORDER BY `cat`,`id` ASC", $cat_id);
		
		// Годовой график
		$year = array();
		for($i=1; $i <= 12; $i++) {
			$year[] = array(
				'date' => date('M y', strtotime( '+'.$i.' month', time()-31536000 )),
				'hits' => '0',
				'visitors' => '0'
			);
		}
		foreach ($sites as $k => $v) {
			$request = $this->db->selectRow("SELECT * FROM month WHERE site = ?d ORDER BY `date` DESC", $v['id']);
			$month = json_decode($request['stats'], true);
			foreach($month as $km){
				foreach($year as $ky => $vy){
					if( $km['date'] == $vy['date'] ){
						
						$year[$ky]['hits'] += $km['hits'];
						$year[$ky]['visitors'] += $km['visitors'];
						
						$profits_all = array();
						foreach($profits as $kp => $vp){
							$profits_all[$kp] = $vp;
							$profits_all[$kp]['data'] = $this->db->selectRow("SELECT * FROM income WHERE source = ?d AND period = ? ORDER BY `id` DESC", $vp['id'], $vy['date']);
							
							$year[$ky]['profits'] = sum_by_array_title($profits_all);
						}
						
						$expenses_all = array();
						foreach($expenses as $ke => $ve){
							$expenses_all[$ke] = $ve;
							$expenses_all[$ke]['data'] = $this->db->selectRow("SELECT * FROM income WHERE source = ?d AND period = ? ORDER BY `id` DESC", $ve['id'], $vy['date']);
							
							$year[$ky]['expenses'] = sum_by_array_title($expenses_all);
						}
					}
				}
			}
		}
		$net_profit = array();
		foreach($year as $key => $val){
			$net_profit[$key] = $val;
			
			$debet = @array_sum($val['profits']);
			$credit = @array_sum($val['expenses']);
			
			$net_profit[$key]['debet'] = $debet;
			$net_profit[$key]['credit'] = $credit;
			
			$net_profit[$key]['hit_1000'] = number_format(($debet / $val['hits'])*1000, 2, '.', '');
			$net_profit[$key]['host_1000'] = number_format(($debet / $val['visitors'])*1000, 2, '.', '');
			
			$all = array_sum($val['profits']) - array_sum($val['expenses']);
			$net_profit[$key]['net_profit'] = $all;
			
			$diff = 0;
			if($all != 0) $diff = $all - $net_profit[($key-1)]['net_profit'];
			if($diff > 0) $diff = '+'.$diff;
			$net_profit[$key]['net_profit_diff'] = $diff;
		}
		$this->assign('finance', $net_profit);
		
		$this->display('finance.tpl');
	}
	
	/**
	 * Регистрация домена в статистике и добавление
	 */
	public function reg() {
		$result = array();
		$reg = new Reg();
		
		if ( isset($_REQUEST['submit_li']) ) {
			$cat = get_req_var('sites_cat', 0);
			$cat_title = $this->db->selectCell("SELECT title FROM cats WHERE id = ?d", intval($cat));
			$sites = get_req_var('sites', '', 'list');
			$email = get_req_var('email', '');
			$pass = get_req_var('pass', random_str(8));
			
			foreach($sites as $site){
				$site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
				$li = false;
				$params = array(
							'cat' => $cat,
							'title' => $cat_title,
							'domain' => $site,
							'email' => ($email) ? $email : 'admin@'.$site,
							'password' => $pass,
							'metrica' => 'li',
							'reg' => 'no',
							'code' => 'Ошибка регистрации в LiveInternet. Сайт не добавлен в панель.',
							'hide' => 'no',
						);
				
				$rid = $this->db->selectCell("SELECT id FROM `sites` WHERE `metrica` = 'li' AND `domain` = ?", $site);
				if( $rid ) {
					$params['email'] = '';
					$params['password'] = '';
					$params['metrica'] = 'none';
					$params['code'] = 'Сайт уже добавлен в панель и зарегистрирован в LiveInternet.';
				}
				else {
					$li = $reg->reg_li($params);
					if($li){
						$params['code'] = $li;
						$params['reg'] = 'yes';
						$hide = $reg->hide_values_li($params);
						if($hide)
							$params['hide'] = 'yes';
					}
					else{
						$params['email'] = '';
						$params['password'] = '';
						$params['metrica'] = 'none';
					}
				}
				
				if($li)
					$this->db->query("INSERT INTO sites SET `domain` = ?, `password` = ?, cat = ?d, metrica = ?", $params['domain'], $params['password'], $params['cat'], $params['metrica']);
				
				array_push($result, $params);
			}
		}
		
		if ( isset($_REQUEST['submit_yam']) ) {
			$cat = get_req_var('sites_cat', 0);
			$cat_title = $this->db->selectCell("SELECT title FROM cats WHERE id = ?d", intval($cat));
			$sites = get_req_var('sites', '', 'list');
			foreach($sites as $site){
				$site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
				$yam = false;
				$params = array(
							'cat' => $cat,
							'title' => $cat_title,
							'domain' => $site,
							'password' => '',
							'metrica' => 'yam',
							'reg' => 'no',
							'code' => 'Ошибка регистрации в Яндекс.Метрике. Сайт не добавлен в панель.'
						);
				
				$rid = $this->db->selectCell("SELECT id FROM `sites` WHERE `metrica` = 'yam' AND `domain` = ?", $site);
				if( $rid ) {
					$params['password'] = '';
					$params['metrica'] = 'none';
					$params['code'] = 'Сайт уже добавлен в панель и зарегистрирован в Яндекс.Метрике.';
				}
				else {
					$yam = $reg->reg_yam($params);
					if(!$yam->errors){
						$params['password'] = $yam->counter->id;
						$params['code'] = $yam->counter->code;
						$params['reg'] = 'yes';
					}
					else{
						$params['password'] = '';
						$params['metrica'] = 'none';
						if($yam->errors[0]->text) $params['code'] = $yam->errors[0]->text .' Сайт добавлен в панель без статистики.';
					}
				}
				
				if($yam)
					$this->db->query("INSERT INTO sites SET `domain` = ?, `password` = ?, cat = ?d, metrica = ?", $params['domain'], $params['password'], $params['cat'], $params['metrica']);
				
				array_push($result, $params);
			}
		}
		
		$this->assign('counter', $result);
		$this->display('reg.tpl');
	}
	
	/**
	 * Страница списка доменов и доб категории
	 */
	public function add() {
		
		// ON/OFF Статистика
		if ( isset($_REQUEST['stat_edit']) ) {
			$id = intval($_REQUEST['id']);
			$stat = intval($_REQUEST['stat_edit']);
			
			$this->db->query("UPDATE sites SET stat = ?d WHERE id = ?d", $stat, $id);
			die();
		}
		
		// ON/OFF Контроль
		if ( isset($_REQUEST['control_edit']) ) {
			$id = intval($_REQUEST['id']);
			$control = intval($_REQUEST['control_edit']);
			
			$this->db->query("UPDATE sites SET control = ?d WHERE id = ?d", $control, $id);
			die();
		}
		
		// ON/OFF SMS
		if ( isset($_REQUEST['sms_edit']) ) {
			$id = intval($_REQUEST['id']);
			$control = intval($_REQUEST['sms_edit']);
			
			$this->db->query("UPDATE sites SET sms = ?d WHERE id = ?d", $control, $id);
			die();
		}
		
		// удалить сайты
		if ( isset($_REQUEST['delete']) ) {
			$id = intval($_REQUEST['delete']);
			$this->db->query("DELETE FROM sites WHERE id = ?d", $id);
			$this->db->query("DELETE FROM stat WHERE site = ?d", $id);
			$this->db->query("DELETE FROM control WHERE site = ?d", $id);
			$this->db->query("DELETE FROM month WHERE site = ?d", $id);
			
			if( strpos($_SERVER['HTTP_REFERER'], 'cat=') !== false ) {
				$url = parse_url($_SERVER['HTTP_REFERER']);
				parse_str($url['query'], $cats);
				if( $cats['cat'] ){
					header('Location: '.$_SERVER['HTTP_REFERER']);
					die();
				}
			}
			
			header('Location: /index.php?do=add');
		}
		
		// выводим страницу с данными
		$this->assign('host', HOST);
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		$count = $this->db->selectCell("SELECT COUNT(*) FROM sites");
		$this->assign('count', $count);
		
		$cats = $this->db->select("SELECT * FROM cats");
		foreach($cats as $c){
			$c['count'] = $this->db->selectCell("SELECT COUNT(*) FROM sites WHERE cat = ?d", $c['id']);
			$cat[] = $c;
		}
		$this->assign('cats', $cat);
		
		$cat_id = isset($_REQUEST['cat']) && intval($_REQUEST['cat']) ? intval($_REQUEST['cat']) : DBSIMPLE_SKIP;
		$this->assign('cat_id', $cat_id);
		
		$sites = $this->db->select("SELECT * FROM sites {WHERE cat = ?d} ORDER BY `cat`,`id` ASC", $cat_id);
		
		foreach ($sites as $k => $site) {
			$sites[$k]['cat'] = $this->db->selectCell("SELECT title FROM cats WHERE id = ?d", $site['cat']);
		}
		
		$this->assign('sites', $sites);
		
		$this->display('add.tpl');
	}
	
	/**
	 * Страница редактирования домена
	 */
	public function edit() {
		$site = get_req_var('site', 0);
		
		// Сохранить
		if ( isset($_REQUEST['submit_edit']) ) {
			$row = array();
			$id = intval($_REQUEST['site']);
			$row['domain'] = $_REQUEST['domain'];
			$row['metrica'] = $_REQUEST['metrica'];
			$row['password'] = $_REQUEST['passwd'];
			$row['cat'] = intval($_REQUEST['cat']);
			$row['sms'] = intval($_REQUEST['sms']);
			$row['stat'] = intval($_REQUEST['stat']);
			$row['control'] = intval($_REQUEST['control']);
			$row['comment'] = $_REQUEST['comment'];
			
			$this->db->query("UPDATE sites SET ?a WHERE id = ?d", $row, $id);
			
			header('Location: /index.php?do=edit&site='.$id);
		}
		
		// Очистить статистику
		if ( isset($_REQUEST['submit_clear']) ) {
			$id = intval($_REQUEST['site']);
			$this->db->query("DELETE FROM stat WHERE site = ?d", $id);
			$this->db->query("DELETE FROM control WHERE site = ?d", $id);
			$this->db->query("DELETE FROM month WHERE site = ?d", $id);
			
			header('Location: /index.php?do=edit&site='.$id);
		}
		
		$site_domain = $this->db->selectRow("SELECT * FROM sites WHERE id = ?d", intval($site));
		$this->assign('domain', $site_domain);
		
		$reg = new Reg();
		if($site_domain['metrica'] == 'yam')
			$counter = $reg->counter_yam($site_domain['password']);
		elseif($site_domain['metrica'] == 'ga')
			$counter = $reg->counter_ga($site_domain['password']);
		elseif($site_domain['metrica'] == 'li')
			$counter = $reg->counter_li();
		else
			$counter = false;
		$this->assign('counter', $counter);
		
		$cats = $this->db->select("SELECT * FROM cats");
		$this->assign('cats', $cats);
		
		$stats = array(array('id' => 'li', 	'metrica' => 'LiveInternet'),
					   array('id' => 'yam', 'metrica' => 'Яндекс.Метрика'),
					   array('id' => 'ga', 	'metrica' => 'Google Analytics'),
					   array('id' => 'none','metrica' => 'Нет'));
		$this->assign('stats', $stats);
		
		$this->display('edit.tpl', 'Редактировать '.$site_domain['domain'], __FUNCTION__);
	}
	
	/**
	 * Страница статистики домена
	 */
	public function graph() {
		$site = get_req_var('site', 0);
		$site_domain = $this->db->selectRow("SELECT * FROM sites WHERE id = ?d", intval($site));
		
		$stats = $this->db->select("SELECT * FROM `stat` WHERE site = ?d ORDER BY `date` DESC LIMIT 30", intval($site));
		foreach ($stats as $k=>$v) {
			$stats[$k]['date_js'] = strtotime($v['date']) * 1000;
			if ( !$stats[$k]['visitors'] ) $stats[$k]['visitors'] = 0;
			if ( !$stats[$k]['hits'] ) $stats[$k]['hits'] = 0;
			if ( $stats[$k]['rkn'] ) $site_domain['rkn'] = true;
		}
		$this->assign('stats', $stats);
		$this->assign('domain', $site_domain);
		
		if($site_domain['rkn']) {
			$google = new Google();
			$rkn = $google->get_antizapret($site_domain['domain'], true);
			$this->assign('rkn', $rkn);
		}
		
		$month = $this->db->selectRow("SELECT * FROM month WHERE site = ?d ORDER BY `date` DESC", intval($site));
		$month = json_decode($month['stats'], true);
		$month = array_slice($month, -12, 12, true);
		
		$this->assign('month', $month);
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		$this->display('graph.tpl', $site_domain['domain'], __FUNCTION__);
	}
	
	/**
	 * Выгрузка ключей
	 */
	public function keys() {
		global $settings;
		$google = new Google($settings->gate_api);
		
		$id = get_req_var('site', 0);
		$start = get_req_var('date_start');
		$end = get_req_var('date_end');
		
		$site = $this->db->selectRow("SELECT * FROM sites WHERE id = ?d", intval($id));
		
		if(!isset($site['password'])) die('Нет доступа к статистике');
		
		$metrica_source = $site['metrica'];
		if ( $metrica_source == 'li' )
			$li = new LiRu($site['domain'], $site['password']);
		
		if ( $metrica_source == 'yam' ) 
			$keys = $google->get_yam_key($site['password'], $start, $end);
		elseif ( $metrica_source == 'ga' )
			$keys = $google->get_ga_key($site['password'], $start, $end);
		elseif ( $metrica_source == 'li' )
			$keys = $li->get_queries($start, $end);
		else
			die('Нет доступа к статистике');
			
		$keys = array_unique($keys); // Отбрасываем дубли
		$keys = array_values($keys); // Пересортировываем
			
		$file = $site['domain'].'-'.$start.'-'.$end.'.txt';
		header("Content-Type: text/html; charset=utf-8");
		header('Content-disposition: attachment; filename='.$file);
		header('Content-type: text/plain');
		
		$temp = tmpfile();
		foreach($keys as $k)
			fwrite($temp, $k.PHP_EOL);
		fseek($temp, 0);
		fpassthru($temp);
		fclose($temp);
	}
	
	
	#Обновление
	public function update() {
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		$this->assign('host', HOST);

		# Текущая версия скрипта
		$version = ( file_exists(ROOT.'/version.php') ) ? intval(file_get_contents(ROOT.'/version.php')) : 0;
		
		# Есть ли новая версия
		$update_url = UPDATE_API_URL . "?act=get_last_version";
		$last_version = file_get_contents($update_url);
		
		$diff_version = $last_version-$version;
		
		$message = "";
		
		#Если получен запрос на обновление
		if (isset($_REQUEST['submit']) ) {
			
			#Если обновления доступны
			if($diff_version>0) {
				#Обновляем!
				ob_start();	
				$this->do_update($version, $last_version);
				$message = nl2br(ob_get_contents());
				ob_end_clean(); #Для удобства вывода ошибок буферизируем все echo
			}
			
			$version = ( file_exists(ROOT.'/version.php') ) ? intval(file_get_contents(ROOT.'/version.php')) : 0;
			$diff_version = $last_version-$version;
		}
		
		$this->assign('diff_version', $diff_version);
		$this->assign('message', $message);
		
		# генерируем шаблон страницы
		$this->display('update.tpl');
	}
	
	#Основная функция обновления
	private function do_update($version, $last_version) {
		
		#Пытаемся создать папку /update, если она существует - удалить её и снова создать пустую
		if ( file_exists(ROOT."/update") ) {
			$dir = new Dir(ROOT."/update");
			$dir->clear();
		} else {
			mkdir(ROOT."/update", 0777);
		}
		
		if ( !file_exists(ROOT."/update") ) {
			echo "Не удалось создать папку /update\n"; 
			return false;
		}
		
		# Патчей может быть много - проходимся по всем
		for ($i = $version+1; $i <= $last_version; $i++) {
			if ( !$this->update_cms($i) ) {
				echo "Патч $i не удалось установить\n";
				return false;
			} else {
				echo "Патч $i установлен!\n";
			}
		}
		
		$dir = new Dir(ROOT."/update");
		$dir->delete();
		
		return true;
	}
	
	#Функция для обновления на указанную версию
	private function update_cms($version) {
		
		#Получаем данные для обновления
		$get_update = UPDATE_API_URL."?act=get_update_data&v=$version";
		$update_data = file_get_contents($get_update);
		$data = unserialize(base64_decode($update_data));
		
		#Скачиваем архив в папку /update
		$file = file_get_contents($data['file']);
		$f = fopen(ROOT."/update/$version.zip", "w");
		if (!$f) {
			echo "Невозможно создать файл для архива\n";
			return false;
		} 
		if (!fwrite($f, $file)) {
			echo "Невозможно записать данные архива\n";
			return false;
		}
		fclose($f);
		
		#Проверяем, сходится ли md5-хеш
		/*if(md5_file(ROOT."/update/$version.zip") != $data['md5_sum']) {
			echo "MD5-hash суммы патчей не сходятся"; return false;
		}*/
		
		#Создаем архив для распаковки этой версии
		if(!mkdir(ROOT."/update/$version")) {
			echo "Невозможно создать папку для распаковки архива\n";
			return false;
		} 

		#Распаковываем zip-архив в папку
		$zip = new ZipArchive();
		if ($zip->open(ROOT."/update/$version.zip") === true) {
	    	$zip->extractTo(ROOT."/update/$version");
	    	$zip->close();
	  	} else {
	  		echo "Невозможно распаковать архив\n";
	  		return false;
	  	} 
		
	  	#Удаляем скачанный архив
	  	unlink(ROOT."/update/$version.zip");
		
	  	#Копируем все файлы и папки из обновления в продакшн
	  	if (!$this->copy_files(ROOT."/update/$version",ROOT)) {
	  		echo "Ошибка при копирования файлов обновления\n";
	  		$this->remove_directory(ROOT."/update/$version"); #Подчищаем за собой в случае ошибки
	  		return false;
	  	}
		
	  	#Удаляем папку с распакованным обновлением
	  	$this->remove_directory(ROOT."/update/$version");
		
	  	#Обновление DB (в php-формате)
	  	if(file_exists(ROOT."/db_update.php")) {
	  		include ROOT."/db_update.php";
	  		unlink(ROOT."/db_update.php");
	  	}
		
	  	#Обновляем версию
	  	file_put_contents(ROOT."/version.php", $version);
		
		return true;
	}
	
	private function copy_files($source, $res){
		if ( !file_exists($source) || !file_exists($res) ) return false;
		
	    $hendle = opendir($source); // открываем директорию
	    while ($file = readdir($hendle)) {
			if ( $file=="." || $file==".." ) continue;
			
			if (is_dir($source."/".$file) == true) {
				if(is_dir($res."/".$file)!=true) mkdir($res."/".$file, 0755);
				$this->copy_files($source."/".$file, $res."/".$file); //Рекурсия!
			} else{
				if(!copy($source."/".$file, $res."/".$file)) { 
					echo "при копировании файла $file произошла ошибка...<br>\n";
					return false; 
				} else {
					echo "$file обновлен\n";
				}
			}
	    } // end while
	    closedir($hendle);
	    return true;
	}
	
	#Функция удаления папки со всеми файлами. Рекурсивна и тренарна)
	private function remove_directory($dir) {
		if ( !file_exists($dir) ) return true;
		
		$dir = new Dir($dir);
		$dir->delete();
		return true;
	}
	
	/**
	 * Страница с настройками скрипта
	 */
	public function settings() {
		
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		// Добавить источники дохода
		if ( isset($_REQUEST['submit_profit']) ) {
			$profits = get_req_var('profit', '', 'list');
			$cat = get_req_var('sites_cat', 0);
			foreach ($profits as $profit) {
				if ( !$profit ) continue;
				$profit = trim($profit);
				
				$data = $this->db->selectRow("SELECT * FROM `sources` WHERE `type` = ? AND `title` = ? AND `cat` = ?d", 'profit', $profit, $cat);
				if(!$data) $this->db->query("INSERT INTO sources SET `type` = ?, `title` = ?, `cat` = ?d", 'profit', $profit, $cat);
			}
			header('Location: /index.php?do=settings');
		}
		
		// Добавить источники расхода
		if ( isset($_REQUEST['submit_expense']) ) {
			$expenses = get_req_var('expense', '', 'list');
			$cat = get_req_var('sites_cat', 0);
			foreach ($expenses as $expense) {
				if ( !$expense ) continue;
				$expense = trim($expense);
				
				$data = $this->db->selectRow("SELECT * FROM `sources` WHERE `type` = ? AND `title` = ? AND `cat` = ?d", 'expense', $expense, $cat);
				if(!$data) $this->db->query("INSERT INTO sources SET `type` = ?, `title` = ?, `cat` = ?d", 'expense', $expense, $cat);
			}
			header('Location: /index.php?do=settings');
		}
		
		// добавить категории
		if ( isset($_REQUEST['submit_cats']) ) {
			$cats = get_req_var('cats', '', 'list');
			foreach ($cats as $cat) {
				if ( !$cat ) continue;
				$cat = trim($cat);
				
				$data = $this->db->selectRow("SELECT * FROM `cats` WHERE `title` = ?", $cat);
				if(!$data) $this->db->query("INSERT INTO cats SET `title` = ?", $cat);
			}
			header('Location: /index.php?do=settings');
		}
		
		// добавить сайты
		if ( isset($_REQUEST['submit']) ) {
			$cat = get_req_var('sites_cat', 0);
			$sites = get_req_var('sites', '', 'list');
			foreach ($sites as $site) {
				if ( !$site ) continue;
				$site = str_replace(array('https://', 'http://', ' '), '', $site);
				@list($domain, $password, $metrica) = explode(':', $site);
				$domain = str_replace(array('/', ' '), '', $domain);
				
				if ( !$domain ) continue;
				if ( !$password ) $password = '';
				if ( !$metrica ) $metrica = 'none';
				
				$data = $this->db->selectRow("SELECT * FROM `sites` WHERE `domain` = ? AND cat = ?d", $domain, $cat);
				if(!$data) $this->db->query("INSERT INTO sites SET `domain` = ?, `password` = ?, cat = ?d, metrica = ?", $domain, $password, $cat, $metrica);
			}
			header('Location: /index.php?do=settings');
		}
		
		# google
		$client = new Google_Client();
		
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $_SERVER['HTTP_HOST'] . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');
		
		$auth_url = $client->createAuthUrl();
		$this->assign('ga_auth_url', $auth_url);
		
		$count = $this->db->selectCell("SELECT COUNT(*) FROM sites");
		$this->assign('count', $count);
		
		$cats = $this->db->select("SELECT * FROM cats");
		$this->assign('cats', $cats);
		
		$pass = random_str(8);
		$this->assign('pass', $pass);
		
		# адрес сайта
		$this->assign('host', HOST);
		
		# Crontab
		$this->assign('root', ROOT);
		
		$php = exec('which php');
		$this->assign('php', $php);
		
		$this->assign('random', generate());
		
		$this->assign('proxy_link_ok_count', count($settings->proxy_link_ok));
		$this->assign('proxy_link_bad_count', count($settings->proxy_link_bad));
		
		# генерируем шаблон страницы
		$this->display('settings.tpl');
	}
	
	/**
	 * Проверка балланса в Антигейт
	 */
	public function antigate() {
		# значения настроек
		global $settings;
		
		require_once LIBS . '/decaptcha/autoload.php';
		$source = 'services\\'.$settings->antigate_source;
		$captcha = new $source([
			$source::ACTION_FIELD_KEY => $settings->gate_api,
		]);
		echo json_encode('Балланс: '. $captcha->getBalance());
	}
	
	/**
	 * Проверка балланса в sms.ru
	 */
	public function sms() {
		# значения настроек
		global $settings;
		$body = file_get_contents("http://sms.ru/my/balance?api_id=".$settings->sms_api);
		
		list($code, $balance) = explode("\n", $body);
		
		if ( $code == "100" )
			$json = 'Балланс: '. $balance .' руб.';
		else
			$json = 'Ошибка';
			
		echo json_encode($json);
	}
	
	/**
	 * Страница проверки прокси
	 */
	public function proxy() {
		# значения настроек
		global $settings;
		$this->assign('settings', $settings);
		
		$this->assign('proxy_link_ok', implode("\n", $settings->proxy_link_ok));
		$this->assign('proxy_link_bad', implode("\n", $settings->proxy_link_bad));
		
		$this->assign('proxy_link_ok_count', count($settings->proxy_link_ok));
		$this->assign('proxy_link_bad_count', count($settings->proxy_link_bad));
		
		$this->assign('time', $settings->proxy_check_time);
		
		$time_elapsed = '<b>'.time_elapsed_string(strtotime($settings->proxy_check_time),time()).' назад</b>';
		$this->assign('time_elapsed', $time_elapsed);
		
		$this->display('proxy.tpl');
	}
	
	public function proxy_check(){
		$proxy = new Proxy();
		$proxy->proxy_check();
		
		echo json_encode('Проверка завершена');
	}
	
}
