<?php
# Запрещаем запуск из бразуера
if(php_sapi_name() !== 'cli') die('Запускать только из коммандной строки');

require_once 'config.php';

# Обновляет все сайты
$sites = $database->select("SELECT * FROM sites WHERE control = 1");

# инициализируем объекты
global $settings;
$google = new Google($settings->gate_api);
$browser = new Curl(true, true, false);
$IDNA = new idna_convert();
$telegram = new Telegram();

# обрабатываем сайты
foreach ($sites as $site) {
	$row = $database->selectRow("SELECT * FROM `control` WHERE `site` = ?d ORDER BY date DESC", $site['id']);
	
	unset($row['id']);
	$row['site'] = $site['id'];
	$row['date'] = date('Y-m-d H:i:s');
	
	$site['domain'] = $IDNA->encode($site['domain']);
   
	if($settings->get_domain_info){
        $domain_info = $google->get_domain_info($site['domain']);
        $row['ip'] = $google->get_ip($site['domain']);
        $row['header'] = $domain_info['header'];
        $row['time'] = $domain_info['time'];
        $row['title'] = $domain_info['title'];
		if($site['sms']){
			if($row['header'] !== '200' && $row['header'] !== '301')
				$sms_domain_info = $site['domain']." ответ сервера ".$row['header'];
			elseif($row['time'] > 30)
				$sms_domain_info = $site['domain']." сайт загружается дольше ".$row['time']." сек";
			elseif($row['title'] == '')
				$sms_domain_info = $site['domain']." не отдает контент";
			if($sms_domain_info)
				$browser->get_page("http://sms.ru/sms/send?api_id={$settings->sms_api}&to={$settings->sms_to}&text=".urlencode($sms_domain_info)."&partner_id=105029");
		}
		if($settings->telegram_token && $settings->telegram_chat_id){
			if($row['header'] !== '200' && $row['header'] !== '301')
				$telegram->send_text( $IDNA->decode($site['domain'])." ответ сервера ".$row['header'] );
			elseif($row['time'] > 30)
				$telegram->send_text( $IDNA->decode($site['domain'])." сайт загружается дольше ".$row['time']." сек" );
			elseif($row['title'] == '')
				$telegram->send_text( $IDNA->decode($site['domain'])." не отдает контент" );
		}
    }
    
    if($settings->get_whois){
        $whois = $google->get_whois($site['domain']);
        if($whois['reg']){
			$row['reg'] = $whois['reg'];
		}
		if($whois['whois_created']) {
			$created = (time() - strtotime($whois['whois_created']))/86400;
			$row['created'] = round($created, 0, PHP_ROUND_HALF_DOWN);
		}
        if($whois['whois_paid']){
			$paid = (strtotime($whois['whois_paid'])  - time())/86400;
			$row['paid'] = round($paid, 0, PHP_ROUND_HALF_DOWN);
		}
		$ssl = $google->get_ssl_info($site['domain']);
		if($ssl['valid_to']) {
			$valid = (strtotime($ssl['valid_to'])  - time())/86400;
			$row['ssl'] = round($valid, 0, PHP_ROUND_HALF_DOWN);
		}
		
		if($site['sms'] && ($row['paid'] > 1 && $row['paid'] < 10)){
				$sms_get_whois = "Необходимо продлить домен ".$site['domain']." осталось ".$row['paid']." д.";
				@file_get_contents("http://sms.ru/sms/send?api_id={$settings->sms_api}&to={$settings->sms_to}&text=".urlencode($sms_get_whois)."&partner_id=105029");
		}
		if($settings->telegram_token && $settings->telegram_chat_id){
			if($row['paid'] > 1 && $row['paid'] < 10) $telegram->send_text( "Необходимо продлить домен ".$IDNA->decode($site['domain'])." осталось ".$row['paid']." д." );
		}
    }
    
	// заносим данные в базу
	foreach ($row as $rk => $rw) if ( is_null($rw) ) $row[ $rk ] = '';
	$rid = $database->selectCell("SELECT id FROM `control` WHERE `site` = ?d", $row['site']);
	if ( $rid )
		$database->query("UPDATE `control` SET ?a WHERE id = ?d", $row, $rid);
	else
		$database->query("INSERT INTO `control` SET ?a", $row);
}

?>