<?php
# Запрещаем запуск из бразуера
if(php_sapi_name() !== 'cli') die('Запускать только из коммандной строки');

require_once 'config.php';

# Обновляет все сайты
$sites = $database->select("SELECT * FROM sites WHERE stat = 1");

# инициализируем объекты
global $settings;
$google = new Google($settings->gate_api);
$browser = new Curl(true, true, false);
$IDNA = new idna_convert();

if($settings->telegram_token && $settings->telegram_chat_id)
	$telegram = new Telegram();
if ( $settings->get_dmca_stat )
	$lumen = new Lumen();

# обрабатываем сайты
foreach ($sites as $site) {
	$row = $database->selectRow("SELECT * FROM `stat` WHERE `site` = ?d ORDER BY date_update DESC", $site['id']);
    
	unset($row['id']);
    $row['site'] = $site['id'];
	$row['date'] = date('Y-m-d');
	$row['date_update'] = date('Y-m-d H:i:s');
	
	$site['domain'] = $IDNA->encode($site['domain']);
    
	// индексация
	if ( $settings->get_ya_stat ) {
		$ya = $google->get_yandex($site['domain']);
		$row['yandex'] = $ya['index'];
		$sba = ( $ya['virus'] ) ? $ya['virus'] : $ya['adalt'];
		$row['sba'] = ( $sba ) ? $sba : '';
		if($site['sms'] && ($ya['virus'] == 'phishing' || $ya['virus'] == 'malware')){
			$sms_virus = "Тип угрозы ".$ya['virus']." на ".$site['domain'];
			$browser->get_page("http://sms.ru/sms/send?api_id={$settings->sms_api}&to={$settings->sms_to}&text=".urlencode($sms_virus)."&partner_id=105029");
		}
		if($settings->telegram_token && $settings->telegram_chat_id){
			if($ya['virus'] == 'phishing' || $ya['virus'] == 'malware') $telegram->send_text( "Тип угрозы ".$ya['virus']." на ".$IDNA->decode($site['domain']) );
		}
	}
	if ( $settings->get_gl_stat )
		$row['google'] = $google->get_indexed($site['domain']);
	if ( $settings->get_yav_stat )
		$row['yandex_video'] = $google->get_yandex_video($site['domain']);
	if ( $settings->get_m_stat )
		$row['mail'] = $google->get_mail($site['domain']);
	if ( $settings->get_bg_stat )
		$row['bing'] = $google->get_bing($site['domain']);
		
	//Пузомерки
	if ( $settings->get_cy_stat )
		$row['cy'] = $google->get_cy($site['domain']);
	if ( $settings->get_pr_stat )
		$row['pr'] = $google->get_pr($site['domain']);
	
	if ( $settings->get_dmca_stat )
		$row['dmca'] = $lumen->get_dmca($site['domain']);
		
		
	
	$row['rkn'] = $google->get_antizapret($site['domain']);
	
	// заносим данные в базу за сегодня
	$rid = $database->selectCell("SELECT id FROM `stat` WHERE `site` = ?d AND `date` = ?", $row['site'], $row['date']);
	if ( $rid )
		$database->query("UPDATE `stat` SET ?a WHERE id = ?d", $row, $rid);
	else
		$database->query("INSERT INTO `stat` SET ?a", $row);
}

// api.promosite.ru
$ap = $google->get_promosite();
if($ap) $settings->save_option('promosite', $ap);

$database->query("DELETE FROM `stat` WHERE `date` < ?", date('Y-m-d', time()-33*24*3600));

?>