<?php
# Запрещаем запуск из бразуера
if(php_sapi_name() !== 'cli') die('Запускать только из коммандной строки');

require_once 'config.php';

# Обновляет все сайты
$sites = $database->select("SELECT * FROM sites WHERE stat = 1");

# инициализируем объекты
global $settings;
$google = new Google($settings->gate_api);
$IDNA = new idna_convert();

# обрабатываем сайты
foreach ($sites as $site) {
	$row = $database->selectRow("SELECT * FROM `stat` WHERE `site` = ?d ORDER BY date_update DESC", $site['id']);
	$row_today = $database->selectRow("SELECT * FROM `stat` WHERE `site` = ?d AND `date` = ? ORDER BY date_update DESC", $site['id'], date('Y-m-d'));
	
	unset($row['id']);
	$row['site'] = $site['id'];
	$row['date'] = date('Y-m-d');
	$row['date_update'] = date('Y-m-d H:i:s');
	
	$site['domain'] = $IDNA->encode($site['domain']);
	
	// статистика посещений
	$metrica_source = $site['metrica'];
	
	if ( $metrica_source == 'li' && ($settings->get_li_stat || $settings->get_wap_stat || $settings->get_ps_stat) && $site['password'] )
		   $li = new LiRu($site['domain'], $site['password']);
	
	if ( $settings->get_li_stat && $site['password'] ) {
		if ( $metrica_source == 'yam' )
			$stat = $google->get_yam_stat($site['password']);
		elseif ( $metrica_source == 'ga' )
			$stat = $google->get_ga_stat($site['password']);
		elseif ( $metrica_source == 'li' )
			$stat = $li->get_stat();
		
		$row['visitors'] = $stat['today_visitors'];
		$row['hits'] = $stat['today_hits'];
		$row['visitors_diff'] = $stat['today_visitors_diff'];
		$row['hits_diff'] = $stat['today_hits_diff'];
	}
	elseif ( !empty($row_today) ){
		$row['visitors'] = ($row_today['visitors']) ? $row_today['visitors'] : 0;
		$row['hits'] = ($row_today['hits']) ? $row_today['hits'] : 0;
		$row['visitors_diff'] = ($row_today['visitors_diff']) ? $row_today['visitors_diff'] : 0;
		$row['hits_diff'] = ($row_today['hits_diff']) ? $row_today['hits_diff'] : 0;
	}
	
	if ( $settings->get_wap_stat && $site['password'] ) {
		if ( $metrica_source == 'li' )
			$wap_stat = $li->get_wap_stat();
		elseif ( $metrica_source == 'ga' )
			$wap_stat = $google->get_ga_wap_stat($site['password']);
		elseif ( $metrica_source == 'yam' )
			$wap_stat = $google->get_yam_wap_stat($site['password']);
		
		$row['wap_visitors'] = $wap_stat['today'];
	}
	elseif ( !empty($row_today) ){
		$row['wap_visitors'] = ($row_today['wap_visitors']) ? $row_today['wap_visitors'] : 0;
	}
	else{
		$row['wap_visitors'] = 0;
	}
	
	if ( $settings->get_ps_stat && $site['password'] ) {
		if ( $metrica_source == 'li' )
			$ps_stats = $li->get_ps_stat();
		elseif ( $metrica_source == 'ga' )
			$ps_stats = $google->get_ga_ps_stat($site['password']);
		elseif ( $metrica_source == 'yam' )
			$ps_stats = $google->get_yam_ps_stat($site['password']);
		
		foreach($ps_stats as $ps_stat){
			if( $ps_stat['ps'] == 'Яндекс') $row['yandex_hits'] = $ps_stat['today'];
			if( $ps_stat['ps'] == 'Google') $row['google_hits'] = $ps_stat['today'];
			if( $ps_stat['ps'] == 'Mail.ru') $row['mail_hits'] = $ps_stat['today'];
			if( $ps_stat['ps'] == 'Bing') $row['bing_hits'] = $ps_stat['today'];
		}
	}
	elseif ( !empty($row_today) ){
		$row['yandex_hits'] = ($row_today['yandex_hits']) ? $row_today['yandex_hits'] : 0;
		$row['google_hits'] = ($row_today['google_hits']) ? $row_today['google_hits'] : 0;
		$row['mail_hits'] = ($row_today['mail_hits']) ? $row_today['mail_hits'] : 0;
		$row['bing_hits'] = ($row_today['bing_hits']) ? $row_today['bing_hits'] : 0;
	}
	else{
		$row['yandex_hits'] = 0;
		$row['google_hits'] = 0;
		$row['mail_hits'] = 0;
		$row['bing_hits'] = 0;
	}
	
	// заносим данные в базу за сегодня
	$rid = $database->selectCell("SELECT id FROM `stat` WHERE `site` = ?d AND `date` = ?", $row['site'], $row['date']);
	if ( $rid )
		$database->query("UPDATE `stat` SET ?a WHERE id = ?d", $row, $rid);
	else
		$database->query("INSERT INTO `stat` SET ?a", $row);
	
	// заносим данные за вчера
	if ( $site['password'] && ($settings->get_li_stat || $settings->get_wap_stat) ) {
		$row_1 = array(
			'site' => $site['id'],
			'date' => date('Y-m-d', time()-24*3600)
		);
		
		if ( $settings->get_li_stat ) {
			$row_1['visitors'] = $stat['yesterday_visitors'];
			$row_1['hits'] = $stat['yesterday_hits'];
		}
		
		if ( $settings->get_wap_stat ){
			$row_1['wap_visitors'] = $wap_stat['yesterday'];
		}
		
		if ( $settings->get_ps_stat ) {
			foreach($ps_stats as $ps_stat){
				if( $ps_stat['ps'] == 'Яндекс') $row_1['yandex_hits'] = $ps_stat['yesterday'];
				if( $ps_stat['ps'] == 'Google') $row_1['google_hits'] = $ps_stat['yesterday'];
				if( $ps_stat['ps'] == 'Mail.ru') $row_1['mail_hits'] = $ps_stat['yesterday'];
				if( $ps_stat['ps'] == 'Bing') $row_1['bing_hits'] = $ps_stat['yesterday'];
			}
		}
		
		$rid_1 = $database->selectCell("SELECT id FROM `stat` WHERE `site` = ?d AND `date` = ?", $row_1['site'], $row_1['date']);
		if ( $rid_1 )
			$database->query("UPDATE `stat` SET ?a WHERE id = ?d", $row_1, $rid_1);
		else
			$database->query("INSERT INTO `stat` SET ?a", $row_1);
	}
}

// api.promosite.ru
$ap = $google->get_promosite();
if($ap) $settings->save_option('promosite', $ap);

$database->query("DELETE FROM `stat` WHERE `date` < ?", date('Y-m-d', time()-33*24*3600));

?>