<?php
// подключаем библиотеку с бд
if ( defined('LIBS') ) {
	if ( file_exists(LIBS . '/DbSimple/Generic.php') ) require_once LIBS . '/DbSimple/Generic.php';
} else {
	if ( file_exists('Generic.php') ) require_once 'Generic.php';
	elseif ( file_exists('DbSimple/Generic.php') ) require_once 'DbSimple/Generic.php';
}

// создаём глобальный экземпляр класса базы данных
global $database;

// если указана база, то подключаемся к ней
if ( $db_name && $db_user ) {
	$database = DBSimple_Generic::connect( "mypdo://$db_user:$db_pass@$db_host/$db_name" );

	$database->setIdentPrefix($db_prefix);              // префикс бд
	$database->setErrorHandler('databaseErrorHandler'); // указываем обработчик ошибок
	$database->query("SET NAMES '$db_collate'");        // кодировка соединения
	$database->query("SET SESSION  wait_timeout = 28800"); 
}

/**
 * Ошибки запросов к бд пишутся в файл logs/db_log.txt, работа скрипта останавливается
 * 
 * @param  string  $message
 * @param  array   $info
 */
function databaseErrorHandler($message, $info) {
	if (!error_reporting()) return; // Если использовалась @, ничего не делать
	
	$log_file_name = ( defined('LOG') ) ? LOG.'/db_log.txt' : 'db_log.txt';
	$log_file = fopen( $log_file_name, 'a' );
	
	fwrite( $log_file, date('d.m.Y H:m:s').":\n" );
	foreach($info as $key=>$value) fwrite($log_file, "[$key] => $value\n");
	fwrite($log_file, "-----------------\n");
	
	fclose($log_file);
	
	echo '<p class="error">Произошла ошибка при обработке вашего запроса к базе данных!</p>';
	
	exit();
}

/**
 * Проверяем, не пропало ли соединение с бд
 */
function database_ping($db_user, $db_pass, $db_host, $db_name, $db_collate, $db_prefix, $db=false) {
	global $database;
	
	$connect = mysqli_ping();
	if ( $connect ) return true;
	
	if ( $db ) {
		$db = DBSimple_Generic::connect( "mysqli://$db_user:$db_pass@$db_host/$db_name" );
		
		$db->setIdentPrefix($db_prefix);              // префикс бд
		$db->setErrorHandler('databaseErrorHandler'); // указываем обработчик ошибок
		$db->query("SET NAMES '$db_collate'");        // кодировка соединения
	} else {
		$database = DBSimple_Generic::connect( "mysqli://$db_user:$db_pass@$db_host/$db_name" );
		
		$database->setIdentPrefix($db_prefix);              // префикс бд
		$database->setErrorHandler('databaseErrorHandler'); // указываем обработчик ошибок
		$database->query("SET NAMES '$db_collate'");        // кодировка соединения
	}
	
	return true;
}
?>