
CREATE TABLE `cats` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `control` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `site` int(11) NOT NULL,
  `ip` varchar(255) NOT NULL,
  `header` int(11) NOT NULL,
  `time` varchar(255) NOT NULL,
  `title` varchar(1024) NOT NULL,
  `reg` varchar(256) NOT NULL,
  `created` varchar(256) NOT NULL,
  `paid` varchar(256) NOT NULL,
  `date` datetime DEFAULT NULL,
  `ssl` varchar(256) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `site` (`site`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `income` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `source` int(11) unsigned NOT NULL,
  `period` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `data` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `month` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `site` int(11) NOT NULL,
  `date` date DEFAULT NULL,
  `stats` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `value` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `sites` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `domain` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `password` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `cat` int(11) unsigned NOT NULL DEFAULT '0',
  `metrica` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'none',
  `comment` text CHARACTER SET utf8 NOT NULL,
  `sms` int(11) unsigned NOT NULL DEFAULT '0',
  `stat` int(11) unsigned NOT NULL DEFAULT '1',
  `control` int(11) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `sources` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `type` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `cat` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `stat` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `site` int(11) NOT NULL,
  `date` date DEFAULT NULL,
  `date_update` datetime DEFAULT NULL,
  `visitors` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `hits` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `visitors_diff` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `hits_diff` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `google` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `google_hits` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `yandex` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `yandex_hits` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `yandex_video` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `bing` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `bing_hits` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `mail` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `mail_hits` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `wap_visitors` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `cy` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `pr` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `sba` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '',
  `rkn` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `dmca` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `site` (`site`),
  KEY `date` (`date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;