Anti Captcha
==============
Меню
--------------
+ [Главная](../docs/README-ru.md)
+ [Documentation in English language](../docs/Anticaptcha-en.md)
+ Якоря
  + [Ссылка](#Ссылка)
  + [Описание сервиса](#Описание-сервиса)
  + [Цены](#Цены)
  + [Описание распознания](#Описание-распознания)
  + [Установка](#Установка)
  + [Примеры](#Примеры)
  + [Описание полей](#Описание-полей)
+ Другой функционал от сервиса
  + [AntiCaptcha ReCaptcha v2 без браузера](../docs/AnticaptchaReCaptchaProxeless-ru.md)
  + [AntiCaptcha ReCaptcha v2 без браузера (с прокси)](../docs/AnticaptchaReCaptcha-ru.md)


Ссылка
--------------
[Ссылка на сервис Anti Captcha](http://infoblog1.ru/goto/anti-captcha)

Описание сервиса
--------------
Сервис AntiCaptcha, ранее белее известный как Antigate.

100% капч распознаются нашими работниками со всего мира. Именно поэтому используя наш сервис вы одновременно помогаете тысячам людей по всему миру обеспечивать себя и своих близких.

Деньги, которые наши работники зарабатывают у нас считаются хорошей зарплатой в таких странах как Индия, Пакистан или Вьетнам. С вашей помощью теперь у них есть выбор между работой на грязном производстве и работой за компьютером.

Цены
--------------
От 0.7 USD за каждые 1000 капч, в зависимости от ваших объемов

Описание распознания
--------------
Решение обычной капчи с текстом.

Установка
--------------
Предпочтительный способ установить это расширение через [composer](http://getcomposer.org/download/).

Либо запустить
```
composer require --prefer-dist jumper423/decaptcha "*"
```
или добавить
```
"jumper423/decaptcha": "*"
```
в файл `composer.json`.


Примеры
--------------
__Инициализация__
Указываем ключ, обязательные и дополнительные параметры. Старайтесь по максимуму их заполнить это способствует более быстрому распознанию капчи.
```
use jumper423\decaptcha\services\Anticaptcha;

$captcha = new Anticaptcha([
    Anticaptcha::ACTION_FIELD_KEY => '94f39af4bb295c40546fba5c932e0d32',
]);
```
__Распознавание__
В первом параметре передаём ссылку или путь на файл с картинкой, во второй параметры распознания при необходимости переопределения тех которые были переданы при инициализации.
```
if ($captcha->recognize('http://site.com/captcha.jpg')) {
    $code = $captcha->getCode();
} else {
    $error = $captcha->getError();
}
```
__Баланс__
```
$balance = $captcha->getBalance();
```
__Язык ошибки__
По умолчанию ошибки на англиском языке, если необходимо переоперелить, сделайте следующее
```
$captcha->setErrorLang(\jumper423\decaptcha\core\DeCaptchaErrors::LANG_RU);
```
__Перехват ошибки__
При желании Вы можете перехватывать ошибку, но для этого надо вызвать setCauseAnError
```
$captcha->setCauseAnError(true);

try {
    $captcha->recognize('http://site.com/captcha.jpg');
    $code = $captcha->getCode();
} catch (\jumper423\decaptcha\core\DeCaptchaErrors $e) {
    ...
}
```


Описание полей
--------------
 Название | Код | Тип | Обяз. | По ум. | Возможные значения | Описание 
 --- | --- | --- | --- | --- | --- | --- 
 Ключ | ACTION_FIELD_KEY | STRING | + |  |  | Ключ от учетной записи |
 Язык | ACTION_FIELD_LANGUAGE | STRING | - | en | en - англоязычная очередь; rn - группа стран Россия, Украина, Беларусь, Казахстан | Определяет язык очереди, в которую должна попасть капча. |
 Картинка | ACTION_FIELD_FILE | STRING | + |  |  | Путь на файл с картинкой или ссылка на него |
 Несколько слов | ACTION_FIELD_PHRASE | BOOLEAN | - |  | false - нет требований; true - работник должен ввести текст с одним или несколькими пробелами | Работник должен ввести текст с одним или несколькими пробелами |
 Регистр | ACTION_FIELD_REGSENSE | BOOLEAN | - |  | false - нет требований; true - работник увидит специальный сигнал что ответ необходимо вводить с учетом регистра | Работник должен ввести ответ с учетом регистра |
 Символы | ACTION_FIELD_NUMERIC | INTEGER | - |  | 0 - нет требований; 1 - можно вводить только цифры; 2 - вводить можно любые символы кроме цифр | Какие символы используется в капче |
 Вычисление | ACTION_FIELD_CALC | BOOLEAN | - |  | false - нет требований; true - работник увидит специальный сигнал что на капче изображено математическое выражение и необходимо ввести на него ответ | На капче изображенно математичекая выражение и её необходимо решить |
 Длина min | ACTION_FIELD_MIN_LEN | INTEGER | - |  |  | Минимальная длина капчи |
 Длина max | ACTION_FIELD_MAX_LEN | INTEGER | - |  |  | Максимальная длина капчи |

