<?php
// test up
/* пути */
define( 'ROOT',     dirname(__FILE__) );
define( 'LIBS',     ROOT.'/libs'      );
define( 'CLASSES',  ROOT.'/classes'   );
define( 'INCLUDES', ROOT.'/includes'  );
define( 'AJAX',     ROOT.'/ajax'      );
define( 'LOG',      ROOT.'/log'       );
define( 'UPD',   	ROOT.'/update'    );
define( 'HOST',     (isset($_SERVER['HTTP_HOST']) ? 'http://'.$_SERVER['HTTP_HOST'] : 'CLI'));
define('UPDATE_API_URL', "http://douglaslab.net/panel/update.php");

/* подключаем классы */
spl_autoload_register ('autoload');
function autoload($class) {
	// некоторые классы подключаются отдельно
	if ($class=='DbSimple_Mysql')    return false;
	if ($class=='Smarty')            return false;
	
	$class = strtolower($class);
	
	// ищем файл в папке classes/core
	if ( strpos($class, 'core_')!==false ) {
		$core_class = explode('_', $class, 2);
		$core_class = end( $core_class );
	
		if ( file_exists(CLASSES."/core/{$core_class}.class.php") ) {
			require_once CLASSES."/core/{$core_class}.class.php";
			return true;
		}
	}
	
	// ищем файл с нужным классом в директории CLASSES
	if ( file_exists(CLASSES."/$class.class.php") ) {
		require_once CLASSES . "/$class.class.php";
		return true;
	}
	
	return false;
}

/* подключаем необходимые файлы */
require_once INCLUDES . '/library.php';   // общие функции
require_once INCLUDES . '/database.php';  // база данных
require_once INCLUDES . '/smarty.php';    // Smarty
require_once INCLUDES . '/google.php';    // Google
require_once INCLUDES . '/init.php';      // инициализация объектов

global $settings;

/* настройки доступа */
$login = isset($settings->login) ? $settings->login : '';
$password = isset($settings->password) ? $settings->password : '';
