/**
 * Управление настройками
 * 
 * @version 1.3.0
 */

function save_option(name, value, result_box) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "save_option",
			'key': name,
			'value': value
		},
		dataType: "text",
		beforeSend: function() {
			if (result_box) {
				$("#"+result_box).html('Отправляю данные');
				$("#"+result_box).fadeIn('fast');
			}
		},
		success: function(html) {
			if (result_box) {
				$("#"+result_box).html(html);
				$("#"+result_box).fadeOut(1000);
			}
		}
	});
}

function save_site(name, value, id, result_box) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "save_site",
			'key': name,
			'value': value,
			'site_id': id,
		},
		dataType: "text",
		beforeSend: function() {
			if (result_box) {
				$("#"+result_box).html('Отправляю данные');
				$("#"+result_box).fadeIn('fast');
			}
		},
		success: function(html) {
			if (result_box) {
				$("#"+result_box).html(html);
				$("#"+result_box).fadeOut(1000);
			}
		}
	});
}

function save_to_option(name, value, add) {
	
	if (add) {
		add_to_option(name, value);
	} else {
		delete_from_option(name, value);
	}
	
	return true;
}

function add_to_option(name, value) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "add_value_to_option",
			'key': name,
			'value': value
		}
	});
}

function delete_from_option(name, value) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "delete_value_from_option",
			'key': name,
			'value': value
		}
	});
}

//****

function save_task_option(task, name, value) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "save_task_option",
			'task_name': task,
			'key': name,
			'value': value
		},
		dataType: "text"
	});
}

function save_to_task_option(task, name, value, add) {
	
	if (add) {
		add_to_task_option(task, name, value);
	} else {
		delete_from_task_option(task, name, value);
	}
	
	return true;
}

function add_to_task_option(task, name, value) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "add_value_to_task_option",
			'task_name': task,
			'key': name,
			'value': value
		}
	});
}

function delete_from_task_option(task, name, value) {
	if ( !value ) value = '';
	
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "delete_value_from_task_option",
			'task_name': task,
			'key': name,
			'value': value
		}
	});
}

function reset_task(task, refresh) {
	$.ajax({
		url: "ajax/settings.php",
		type: "post",
		data: {
			'task': "reset_task",
			'task_name': task
		},
		success: function() {
			if ( refresh ) window.location.reload();
		}
	});
}
