<form method="get" class="form-inline" action="index.php">
	<input type="hidden" name="do" value="finance" />
	
	<div class="form-group" class="sr-only" >
		<label for="sites">Категория:</label>
		<select class="form-control" name="cat">
			<option value="">Все - {$count}</option>
			{foreach from=$cats item=cat}
				{if $cat.count}
				<option value="{$cat.id}" {if $cat.id eq $cat_id}selected{/if} >{$cat.title} - {$cat.count}</option>
				{/if}
			{/foreach}
		</select>
		<button type="submit" class="btn btn-default">Вывести</button>
	</div>
</form>

<table class="table table-bordered table-finance">
    <thead>
        <tr>
			<th colspan="3">Статистика</th>
            {if ( $profits_count > 0 )}<th colspan="{$profits_count}">Доходы</th>{/if}
            {if ( $expenses_count > 0 )}<th colspan="{$expenses_count}">Расходы</th>{/if}
            {if ( $profits_count > 0 || $expenses_count > 0 )}<th rowspan="2">Прибыль</th>{/if}
        </tr>
        <tr>
            <th>Месяц</th>
            <th>Хосты</th>
            <th>Хиты</th>
            {foreach from=$profits item=profit}
                <th><nobr>{$profit.title}</nobr></th>
            {/foreach}
            {foreach from=$expenses item=expense}
                <th><nobr>{$expense.title}</nobr></th>
            {/foreach}
        </tr>
	</thead>
    
    {foreach from=$finance item=graph}
        {if ( $graph.visitors > 0 || $graph.hits > 0 )}
        <tr>
            <td style="text-align:left"><nobr><b>{$graph.date}</b></nobr></td>
            <td>{$graph.visitors}</td>
            <td>{$graph.hits}</td>
            {foreach from=$graph.profits item=profit}
                <td>{$profit}</td>
            {/foreach}
            {foreach from=$graph.expenses item=expense}
                <td>{$expense}</td>
            {/foreach}
            {if ($profits || $expenses)}<td><nobr>{$graph.net_profit}<sup class="{if $graph.net_profit_diff > 0}green{elseif $graph.net_profit_diff < 0}red{/if}">{if $graph.net_profit_diff != 0}{$graph.net_profit_diff}{/if}</sup></nobr></td>{/if}
        </tr>
        {/if}
    {/foreach}
</table>

{if $cat_id > 0 and ($profits || $expenses)}
<form method="post" action="index.php?do=finance&income=1">
	<fieldset>
		<legend>Добавить данные</legend>
		<br>
		<input type="hidden" name="do" value="finance" />
		<input type="hidden" name="cat" value="{$cat_id}" />
		
		<table class="table table-bordered table-finance table-finance-add">
			<thead>
				<tr>
					<th rowspan="2">Месяц</th>
					{if ( $profits_count > 0 )}<th colspan="{$profits_count}">Доходы</th>{/if}
					{if ( $expenses_count > 0 )}<th colspan="{$expenses_count}">Расходы</th>{/if}
				</tr>
				<tr>
					{foreach from=$profits item=profit}
						<th><nobr>{$profit.title} <sup><a href="/index.php?do=finance&cat={$cat_id}&remove={$profit.id}" title="Удалить источник дохода"><i class="icon-remove"></i></a></sup></nobr></th>
					{/foreach}
					{foreach from=$expenses item=expense}
						<th><nobr>{$expense.title} <sup><a href="/index.php?do=finance&cat={$cat_id}&remove={$expense.id}" title="Удалить источник расхода"><i class="icon-remove"></i></a></sup></nobr></th>
					{/foreach}
				</tr>
			</thead>
			<tbody>
				<tr>
					<td style="text-align:left">
						<select class="input-small" name="period">
							{foreach from=$finance item=graph}
								{if ( $graph.visitors > 0 || $graph.hits > 0 )}
								<option value="{$graph.date}">{$graph.date}</option>
								{/if}
							{/foreach}
						</select>
					</td>
					{foreach from=$profits item=profit}
						<td><input type="text" name="{$profit.type}[{$profit.id}]" value="" class="input-small"/></td>
					{/foreach}
					{foreach from=$expenses item=expense}
						<td><input type="text" name="{$expense.type}[{$expense.id}]" value="" class="input-small"/></td>
					{/foreach}
				</tr>
			</tbody>
		</table>
		<button type="submit" class="btn btn-default">Добавить</button>
	</fieldset>
</form>
{/if}

<hr />

<div id="profit_chart_div" style="width: 100%; height: 300px;"></div>

<div id="div_1000" style="width: 100%; height: 300px;"></div>

<hr />

<script type="text/javascript" src="https://www.google.com/jsapi"></script>
<script type="text/javascript">
	{literal}
		google.load('visualization', '1.0', {'packages':['corechart']});
	{/literal}
	google.setOnLoadCallback(drawChart);
	function drawChart() {
		var data = new google.visualization.DataTable();
		data.addColumn('string', 'Дата');
		data.addColumn('number', 'Доходы');
		data.addColumn('number', 'Расходы');
		data.addColumn('number', 'Прибыль');
		data.addRows([
			{foreach from=$finance item=graph}
				{if ( $graph.visitors > 0 || $graph.hits > 0 )}
				['{$graph.date}',{$graph.debet|default:0},{$graph.credit|default:0},{$graph.net_profit|default:0}],
				{/if}
			{/foreach}
		]);
		{literal}
			var options = {'title':'Прибыльность:',colors: ['green','blue','red',],};
		{/literal}
		var chart = new google.visualization.LineChart(document.getElementById('profit_chart_div'));
		chart.draw(data, options);
	}
</script>

<script type="text/javascript">
	google.setOnLoadCallback(drawChart);
	function drawChart() {
		var data = new google.visualization.DataTable();
		data.addColumn('string', 'Дата');
		data.addColumn('number', '1000 Хитов');
		data.addColumn('number', '1000 Хостов');
		data.addRows([
			{foreach from=$finance item=graph}
				{if ( $graph.visitors > 0 || $graph.hits > 0 )}
				['{$graph.date}',{$graph.hit_1000|default:0},{$graph.host_1000|default:0}],
				{/if}
			{/foreach}
		]);
		{literal}
			var options = {'title':'Качество монетизации:',colors: ['blue','green'],};
		{/literal}
		var chart = new google.visualization.LineChart(document.getElementById('div_1000'));
		chart.draw(data, options);
	}
</script>
